REM $DBA/alltabp.sql
REM Creates a report of all table grants
set echo off term off feedback off verify off
set pagesize 9999
set concat +
spool alltabp.lis
set concat .
ttitle left 'alltabp - All Table Privileges' skip 2
break on grantor on grantee on table_name
column grantor format a9 heading 'Grantor'
column grantee format a10 heading 'Grantee'
column privilege format a9 heading 'Privilege'
column owner format a9 heading 'Owner'
column table_name format a35 heading 'Table Name'
column grantable format a3 heading 'Grantable'
select grantor, grantee, table_name, privilege,
decode(owner,grantor,'',owner) Owner,
decode(grantable,'NO','',grantable) Grantable
from dba_tab_privs order by grantor, grantee, table_name;
spool off
exit
