rem $DBA/audhot.sql
rem
rem Creates a report of the "hot" tables and views.
rem
set echo off
set feedback off
set pagesize 9999
set term off
set verify off
spool audhot.lis
col cnt format 999999 heading "Count"
col obj_name format a30 heading "Object Name"
col username format a20 heading "Username"
col mdy format a8 heading "Date"
ttitle center 'Hot tables report (all operations, all users, all dates)' skip 2
select count(*) cnt, obj_name
	from dba_audit_object
	where action_name IN ('DELETE', 'INSERT', 'SELECT', 'UPDATE')
	group by obj_name
	order by 1 desc;
ttitle center 'Hot tables report (DELETE operations, all users, all dates)' -
	skip 2
select count(*) cnt, obj_name
	from dba_audit_object
	where action_name = 'DELETE'
	group by obj_name
	order by 1 desc;
ttitle center 'Hot tables report (INSERT operations, all users, all dates)' -
	skip 2
select count(*) cnt, obj_name
	from dba_audit_object
	where action_name = 'INSERT'
	group by obj_name
	order by 1 desc;
ttitle center 'Hot tables report (SELECT operations, all users, all dates)' -
	skip 2
select count(*) cnt, obj_name
	from dba_audit_object
	where action_name = 'SELECT'
	group by obj_name
	order by 1 desc;
ttitle center 'Hot tables report (UPDATE operations, all users, all dates)' -
	skip 2
select count(*) cnt, obj_name
	from dba_audit_object
	where action_name = 'UPDATE'
	group by obj_name
	order by 1 desc;
ttitle center -
	'Hot tables report (by object, by user, all operations, all dates)' -
	skip 2
select count(*) cnt, obj_name, username
	from dba_audit_object
	where action_name IN ('DELETE', 'INSERT', 'SELECT', 'UPDATE')
	group by obj_name, username
	order by 1 desc;
ttitle center -
	'Hot tables report (by user, by object, all operations, all dates)' -
	skip 2
select count(*) cnt, username, obj_name
	from dba_audit_object
	where action_name IN ('DELETE', 'INSERT', 'SELECT', 'UPDATE')
	group by username, obj_name
	order by 1 desc;
ttitle center -
	'Hot tables report (by object, by date, all operations, all users)' -
	skip 2
select count(*) cnt, obj_name, to_char(timestamp, 'MM/DD/YY') mdy
	from dba_audit_object
	where action_name IN ('DELETE', 'INSERT', 'SELECT', 'UPDATE')
	group by obj_name, to_char(timestamp, 'MM/DD/YY')
	order by 1 desc;
ttitle center -
	'Hot tables report (by object, by date, by user, all operations)' -
	skip 2
select count(*) cnt, obj_name, to_char(timestamp, 'MM/DD/YY') mdy, username
	from dba_audit_object
	where action_name IN ('DELETE', 'INSERT', 'SELECT', 'UPDATE')
	group by obj_name, to_char(timestamp, 'MM/DD/YY'), username
	order by 1 desc;
ttitle center -
	'Hot tables report (by user, by date, all operations, all objects)' -
	skip 2
select count(*) cnt, username, to_char(timestamp, 'MM/DD/YY') mdy
	from dba_audit_object
	where action_name IN ('DELETE', 'INSERT', 'SELECT', 'UPDATE')
	group by username, to_char(timestamp, 'MM/DD/YY')
	order by 1 desc;
ttitle center -
	'Hot tables report (by user, by date, by object, all operations)' -
	skip 2
select count(*) cnt, username, to_char(timestamp, 'MM/DD/YY') mdy, obj_name
	from dba_audit_object
	where action_name IN ('DELETE', 'INSERT', 'SELECT', 'UPDATE')
	group by username, to_char(timestamp, 'MM/DD/YY'), obj_name
	order by 1 desc;
spool off
set term on
prompt Created audhot.lis...
exit
