rem $DBA/descview.sql
rem
rem Performs a DESCRIBE of each of the V$ and DBA_ views to a file, so that
rem these can be compared to new Oracle versions to see what views are new or
rem have been modified.
rem
rem Last Change 04/10/97 by Brian Lomasky
rem
set echo off
set feedback off
set heading off
set pagesize 0
set termout off
set verify off
spool desctmp.sql
select 'set echo off' from dual;
select 'set feedback off' from dual;
select 'set heading off' from dual;
select 'set pagesize 0' from dual;
select 'set termout off' from dual;
select 'set verify off' from dual;
select 'spool descview.lis' from dual;
select 'prompt For ' || banner || chr(10)
	from v$version where banner like '%Server%';
select 'select ' || '''' || view_name || ':''' || ' from dual;' || chr(10) ||
	'describe ' || rtrim(owner) || '.' || view_name
	from dba_views
	where view_name like 'DBA_%' or view_name like 'V_$%'
	order by view_name;
select 'spool off' from dual;
spool off
@desctmp.sql
set termout on
host rm desctmp.sql
prompt Created descview.lis for your viewing pleasure...
exit
