rem $DBA/file_use.sql
rem
rem Changed 08/01/97 by Brian Lomasky - Removed sequence#.  Increased sizes.
rem Changed 03/18/97 by Brian Lomasky - Increased size of MB column
rem Changed 12/19/96 by Brian Lomasky - Calculate database name and report date
rem Changed 12/17/96 by Brian Lomasky - Divided bytes by 1048576 (was 1000000),
rem					  Removed rem statements from SELECT,
rem					  Included "set verify off"
rem Changed 07/26/96 by Brian Lomasky - Increased MB field size
rem Changed 06/26/96 by Brian Lomasky - Added archive log mode desc
rem
set echo off
set feedback off
set linesize 80
set pagesize 62
set termout off
set verify off
rem
rem Calculate database name and report date
rem
column dbname noprint new_value sid
column now noprint new_value today
select name dbname, to_char(sysdate, 'MM/DD/YY') now from v$database;
set termout on
ttitle skip 2 left &today center 'FILE_USE - Files for database ' &sid skip 2
column type heading 'Type'
column tablespace_name format A17 heading 'Tablesp'
column file_name format A42 heading 'File Name'
column MB format 99999B heading 'Act MB|on|Disk'
column stat format A5 heading 'Stat'
break on tablespace_name nodup on report
compute sum of mb on report
spool file_use.lst
set termout off
select 'Data' type, tablespace_name,
  REPLACE(file_name,'?','&&1') file_name,
  bytes/1048576 MB,
  decode(status,'AVAILABLE','Avail','INVALID','Inval','****') stat
from dba_data_files
union
select 'Redo', 'Grp ' || a.group#, member, bytes/1048576 MB,
  decode(b.status,'CURRENT','Curr','INACTIVE','Inact','UNUSED','Unuse','****')
from v$logfile a, v$log b
where a.group# = b.group#
union
select 'Parm', 'Ctrl 1',
  REPLACE(nvl(ltrim(substr(value,1,instr(value||',',',',1,1)-1)),'  (none)'),
  '?','&&1') file_name,
  0, ''
from v$parameter where name = 'control_files'
union
select 'Parm', 'Ctrl 2',
  REPLACE(nvl(ltrim(substr(value,instr(value||',',',',1,1)+1,
  instr(value||',',',',1,2)-instr(value||',',',',1,1)-1)),'  (none)'),
  '?','&&1') file_name,
  0, ''
from v$parameter where name = 'control_files'
union
select 'Parm', 'Ctrl 3',
  REPLACE(nvl(ltrim(substr(value,instr(value||',',',',1,2)+1,
  instr(value||',',',',1,3)-instr(value||',',',',1,2)-1)),'  (none)'),
  '?','&&1') file_name,
  0, ''
from v$parameter where name = 'control_files'
union
select 'Parm', 'Ctrl 4',
  REPLACE(nvl(ltrim(substr(value,instr(value||',',',',1,3)+1,
  instr(value||',',',',1,4)-instr(value||',',',',1,3)-1)),'  (none)'),
  '?','&&1') file_name,
  0, ''
from v$parameter where name = 'control_files'
union
select 'Parm', 'Ifile', REPLACE(value,'?','&&1') file_name, 0, ''
from v$parameter where name = 'ifile'
union
select 'Parm', 'Archive', DECODE(d.log_mode, 'ARCHIVELOG',
	REPLACE(p.value,'?','&&1') || ' - ENABLED',
	REPLACE(p.value,'?','&&1') || ' - Disabled') file_name,
	0, ''
from v$parameter p, v$database d
where p.name = 'log_archive_dest'
order by 1, 2, 3;
spool off
set termout on
rem prompt Created file_use.lst for your viewing pleasure...
exit
