rem    $DBA/getgrant.sql
rem
rem    This script creates the grant statements necessary to re-generate
rem    the table-level and column-level grants for the user-entered table
rem    name, when that table is re-created.
rem
rem    This script is for Oracle 7.1.4 or later.
rem
rem    Written 03/18/96 by Brian Lomasky
rem
prompt Creating SQL-script (regrant.sql) to re-generate grants for a given table

accept in_table char prompt 'Enter table name to record grants from: '
prompt

set verify off
set termout off
set pagesize 0
set feedback off

spool regrant.sql

prompt prompt Creating grants for new table "&in_table."

SELECT 'GRANT '||privilege||' on '||owner||'.'||'&in_table to '||grantee||
	decode(grantable,'YES',' with grant option;',';')
	FROM dba_tab_privs
	WHERE table_name = UPPER('&in_table');

spool off
set termout on
prompt
prompt Created regrant.sql for your viewing pleasure...
prompt
exit
