rem $DBA/indcols.sql
rem
rem Prints a report of all indexes (and the coulmns that comprise each index)
rem for a specific table in a database.
rem
set feedback off
set pagesize 9999
set termout on
set verify off
column tnam format a28 heading "Table Name"
column inam format a28 heading "Index Name"
column column_name format a20 heading "Column Name"
ttitle left 'INDCOLS - Indexes (and their columns) on table '&&1 skip 2
spool indcols.lis
break on tnam skip on inam skip
SELECT rtrim(table_owner)||'.'||table_name tnam,
	rtrim(index_owner)||'.'||index_name inam, column_name
	FROM dba_ind_columns
	WHERE table_name = '&&1'
	order by 1, 2, 3;
spool off
exit
