rem $DBA/nondata.sql
rem
rem This looks at non-data objects within the RDBMS
rem
column owner noprint new_value owner_var
column segment_name format a20 heading "Object name"
column segment_type format a9 heading "Tabl/Indx"
column sum(bytes) format 999,999,999 heading "Bytes Used"
column sum(blocks) format 99,999 heading "Blocks"
column count(*) format 999 heading "No."
break on owner skip page 2
ttitle center ' Listing of Non-Data RDBMS Objects' skip 2
select owner, segment_name, segment_type, sum(bytes), sum(blocks), count(*)
from dba_extents
where segment_type not in ('TABLE','INDEX','CLUSTER','ROLLBACK')
group by owner, segment_name, segment_type
order by owner, segment_name, segment_type;
exit
