rem $DBA/connect.sql
rem
rem Displays connect time of all sessions
rem
rem Revision History:
rem   3/30/98 - Dave Kreines - Modify for 7.3 and above (thanks
rem                            to Brian Lasky)
rem
set linesize 80
set pagesize 9999
set tab off
column pid format 999
column spid format a5
column sid format 9999
column ora_user format a10
column unix_user format a10
column whenon format a20 heading "WHEN USER LOGGED ON"
column whendo format a20 heading "WHEN LAST ACTIVITY"
select p.pid, p.spid, s.sid, lower(s.username) ora_user, p.username unix_user,
       to_char(s.logon_time,'mm/dd/yy hh24:mi:ss') whenon,
       to_char(sysdate - (s.last_call_et) / 86400,'mm/dd/yy hh24:mi:ss') whendo
from v$process p, v$session s
where s.paddr(+) = p.addr
order by s.logon_time;
rem
rem Use the following script for Oracle version 7.2 and before:
rem
rem select p.pid, p.spid, s.sid, lower(s.username) ora_user, p.username unix_user,
rem to_char(sysdate - (t.hsecs - t1.value) / 86400000,'mm/dd/yy hh24:mi:ss') whenon,
rem to_char(sysdate - (t.hsecs - t2.value) / 86400000,'mm/dd/yy hh24:mi:ss') whendo
rem from v$process p, v$session s, v$sesstat t1, v$sesstat t2, v$timer t,
rem         v$statname n1, v$statname n2
rem where   t1.statistic# = n1.statistic# and n1.name = 'session connect time' and
rem         t2.statistic# = n2.statistic# and n2.name = 'process last non-idle time'
rem         and s.paddr (+) = p.addr and
rem         t1.sid = s.sid and
rem         t2.sid = s.sid and
rem         nvl(t1.value, 0) != 0
rem order by t1.value;
