rem DBA:BAD_CONS.SQL
rem
rem Displays information about the constraints whose owner of the primary key
rem constraint does not match the table's owner.
rem
rem This causes ORA-00600 errors having an argument of 12838 to appear in
rem trace dump files.
rem
rem Fix this by disabling the constraint, and re-enabling it while connecting
rem as the table's owner.
rem
rem Created 08/27/96 by Brian Lomasky
rem
col town format a12 heading "Table|Owner"
col iown format a12 heading "Index|Owner"
col constraint_name format a25
col table_name format a25
set pagesize 9999
spool bad_cons.lis
select t.owner town, i.owner iown, c.constraint_name, c.table_name
from dba_constraints c, dba_indexes i, dba_tables t
where	c.constraint_type = 'P' and
	c.constraint_name = i.index_name and
	c.table_name = i.table_name and
	c.table_name = t.table_name and
	t.owner <> i.owner
	order by 3;
spool off
prompt Created bad_cons.lis report file...
exit
