rem $DBA/crsyns.sql
rem
rem This script generates another script that will include all the CREATE
rem SYNONYM statements for those in the database.
rem
rem This script must be run by a user with the DBA role under Oracle7.
rem
rem Created 10/21/96 by Brian Lomasky
rem
set verify off
set feedback off
set echo off
set pagesize 0
set termout on
select 'Creating database synonym build script...' from dual;

create table syn_temp (	lineno NUMBER,
			text VARCHAR2(80));

declare
	cursor syn_cursor is select
		owner,
		synonym_name,
		table_owner,
		table_name,
		db_link
		from sys.dba_synonyms
		order by owner, synonym_name;

	lv_owner		sys.dba_synonyms.owner%TYPE;
	lv_synonym_name		sys.dba_synonyms.synonym_name%TYPE;
	lv_table_owner		sys.dba_synonyms.table_owner%TYPE;
	lv_table_name		sys.dba_synonyms.table_name%TYPE;
	lv_db_link		sys.dba_synonyms.db_link%TYPE;
	lv_lineno		number;
	a_lin			varchar2(80);

	function wri(x_lin in varchar2, x_str in varchar2,
		x_force in number) return varchar2 is
	begin
		if length(x_lin) + length(x_str) > 80
		then
			lv_lineno := lv_lineno + 1;
			insert into syn_temp values (lv_lineno, x_lin);
			if x_force = 0
			then
				return '    '||x_str;
			else
				lv_lineno := lv_lineno + 1;
				if substr(x_lin,1,2) = '  '
				then
					insert into syn_temp values (
						lv_lineno, x_str);
				else
					insert into syn_temp values (
						lv_lineno, '    '||x_str);
				end if;
				return '';
			end if;
		else
			if x_force = 0
			then
				return x_lin||x_str;
			else
				lv_lineno := lv_lineno + 1;
				insert into syn_temp values (
					lv_lineno, x_lin||x_str);
				return '';
			end if;
		end if;
	end wri;

begin
	a_lin := '';
	lv_lineno := 0;
	open syn_cursor;
	loop
		fetch syn_cursor into
			lv_owner,
			lv_synonym_name,
			lv_table_owner,
			lv_table_name,
			lv_db_link;
		exit when syn_cursor%NOTFOUND;
		if lv_owner = 'PUBLIC' then
			a_lin := wri(a_lin, 'CREATE PUBLIC SYNONYM ', 0);
		else
			a_lin := wri(a_lin, 'CREATE SYNONYM '||
				lv_owner || '.', 0);
		end if;
		a_lin := wri(a_lin, lv_synonym_name, 0);
		a_lin := wri(a_lin, ' for ', 0);
		if lv_db_link != ' ' then
			a_lin := wri(a_lin, lv_table_owner || '.' ||
				lv_table_name || '@' || lv_db_link, 0);
		else
			a_lin := wri(a_lin, lv_table_owner || '.' ||
				lv_table_name, 0);
		end if;
		a_lin := wri(a_lin, ';', 1);
	end loop;
	close syn_cursor;
	a_lin := wri(a_lin, 'exit', 1);
end;
/

set termout off
set heading off
spool cr_syn.sql
select 'rem cr_syn.sql' from dual;
select 'rem' from dual;
select 'rem ***** All synonyms for database ' || name from v$database;
select 'rem' from dual;
select 'set feedback off' from dual;
select text from syn_temp order by lineno;
spool off
drop table syn_temp;
set termout on
select 'Created cr_syn.sql...' from dual;
set termout off
exit
