rem $DBA/drop_obj.sql
rem
rem Drops the specified object, if it exists.  No drop if no existing object.
rem
rem &1 = Type of object.  One of:  TABLE, SYNONYM
rem &2 = Object name to be dropped.
rem
whenever sqlerror exit failure
set pagesize 0
set linesize 80
set heading off
set feedback off
set echo off
set termout off
set verify off
spool drop_obj_temp.sql
select 'set feedback off' from dual;
select 'set termout on' from dual;
select 'set verify off' from dual;
select 'whenever sqlerror exit failure' from dual;
select 'set echo on' from dual;
select 'set feedback on' from dual;
select 'drop table ' || rtrim(owner) || '.' || '&2;'
from dba_tables
where upper('&1') = 'TABLE' and table_name = upper('&2');
select 'drop public synonym ' || '&2;'
from dba_synonyms
where upper('&1') = 'SYNONYM' and synonym_name = upper('&2');
spool off
@drop_obj_temp
host rm drop_obj_temp.sql
exit
