rem locate2.sql
rem
rem Called by location to create the location report.
rem
rem Last Change 07/10/97 by Brian Lomasky
rem
set feedback off
set echo off
set termout off
set verify off
drop table location_locate_temp;
drop table location_locate_temp2;
set termout on
create table location_locate_temp (
	dir1 varchar2(50),
	dir2 varchar2(50),
	dir3 varchar2(50),
	dir4 varchar2(50),
	dir5 varchar2(50),
	dir6 varchar2(50),
	dir7 varchar2(50),
	dir8 varchar2(50),
	dir9 varchar2(50),
	dir10 varchar2(50),
	dir11 varchar2(50),
	dir12 varchar2(50),
	dir13 varchar2(50),
	dir14 varchar2(50),
	dir15 varchar2(50),
	dir16 varchar2(50),
	path varchar2(50),
	sid varchar2(8),
	type varchar2(4),
	tablespace varchar2(30),
	mbytes number,
	status varchar2(5));

create table location_locate_temp2 (
	lineno number,
	path varchar2(50),
	sid varchar2(8),
	type varchar2(4),
	tablespace varchar2(30),
	mbytes number,
	status varchar2(5));

declare
	cursor locate_cur is
		select filespec, sid, type, tablespace, mbytes, status
		from location_all_db_temp;

	cursor locate_cur2 is
		select dir1, dir2, dir3, dir4, dir5, dir6, dir7, dir8, dir9,
			dir10, dir11, dir12, dir13, dir14, dir15, dir16, path,
			sid, type, tablespace, mbytes, status
		from location_locate_temp
		order by 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 13, 14, 15, 16,
		sid, type, path;

	lv_dir1		varchar2(50);
	lv_dir2		varchar2(50);
	lv_dir3		varchar2(50);
	lv_dir4		varchar2(50);
	lv_dir5		varchar2(50);
	lv_dir6		varchar2(50);
	lv_dir7		varchar2(50);
	lv_dir8		varchar2(50);
	lv_dir9		varchar2(50);
	lv_dir10	varchar2(50);
	lv_dir11	varchar2(50);
	lv_dir12	varchar2(50);
	lv_dir13	varchar2(50);
	lv_dir14	varchar2(50);
	lv_dir15	varchar2(50);
	lv_dir16	varchar2(50);
	lv_path		varchar2(50);
	lv_filespec	location_all_db_temp.filespec%TYPE;
	lv_sid		location_all_db_temp.sid%TYPE;
	lv_type		location_all_db_temp.type%TYPE;
	lv_tablespace	location_all_db_temp.tablespace%TYPE;
	lv_mbytes	location_all_db_temp.mbytes%TYPE;
	lv_status	location_all_db_temp.status%TYPE;
	subtotal	number;
	grandtotal	number;
	slash_pos	number;
	last_slash_pos	number;
	nth		number;
	is_path		number;
	linenum		number;
	prev_dir1	varchar2(50);
	prev_dir2	varchar2(50);
	prev_dir3	varchar2(50);
	prev_dir4	varchar2(50);
	prev_dir5	varchar2(50);
	prev_dir6	varchar2(50);
	prev_dir7	varchar2(50);
	prev_dir8	varchar2(50);
	prev_dir9	varchar2(50);
	prev_dir10	varchar2(50);
	prev_dir11	varchar2(50);
	prev_dir12	varchar2(50);
	prev_dir13	varchar2(50);
	prev_dir14	varchar2(50);
	prev_dir15	varchar2(50);
	prev_dir16	varchar2(50);

	procedure write_record is
	begin
		if is_path = 1 then
			insert into location_locate_temp values (
				lv_dir1,
				lv_dir2,
				lv_dir3,
				lv_dir4,
				lv_dir5,
				lv_dir6,
				lv_dir7,
				lv_dir8,
				lv_dir9,
				lv_dir10,
				lv_dir11,
				lv_dir12,
				lv_dir13,
				lv_dir14,
				lv_dir15,
				lv_dir16,
				lv_path,
				' ',
				' ',
				' ',
				0,
				' ');
		else
			insert into location_locate_temp values (
				lv_dir1,
				lv_dir2,
				lv_dir3,
				lv_dir4,
				lv_dir5,
				lv_dir6,
				lv_dir7,
				lv_dir8,
				lv_dir9,
				lv_dir10,
				lv_dir11,
				lv_dir12,
				lv_dir13,
				lv_dir14,
				lv_dir15,
				lv_dir16,
				lv_path,
				lv_sid,
				lv_type,
				lv_tablespace,
				lv_mbytes,
				lv_status);
		end if;
	end write_record;
begin
	open locate_cur;
	loop
		fetch locate_cur into
			lv_filespec,
			lv_sid,
			lv_type,
			lv_tablespace,
			lv_mbytes,
			lv_status;
		exit when locate_cur%NOTFOUND;
		lv_dir1 := ' ';
		lv_dir2 := ' ';
		lv_dir3 := ' ';
		lv_dir4 := ' ';
		lv_dir5 := ' ';
		lv_dir6 := ' ';
		lv_dir7 := ' ';
		lv_dir8 := ' ';
		lv_dir9 := ' ';
		lv_dir10 := ' ';
		lv_dir11 := ' ';
		lv_dir12 := ' ';
		lv_dir13 := ' ';
		lv_dir14 := ' ';
		lv_dir15 := ' ';
		lv_dir16 := ' ';
		is_path := 1;
		nth := 1;
		last_slash_pos := 1;
		slash_pos := instr(lv_filespec, '/', 2, nth);
		while slash_pos != 0
		loop
			if nth = 1 then
				lv_dir1 := substr(lv_filespec,
					last_slash_pos + 1,
					slash_pos - last_slash_pos - 1);
				lv_path := lv_dir1;
				write_record;
			elsif nth = 2 then
				lv_dir2 := substr(lv_filespec,
					last_slash_pos + 1,
					slash_pos - last_slash_pos - 1);
				lv_path := substr('  '||lv_dir2, 1, 50);
				write_record;
			elsif nth = 3 then
				lv_dir3 := substr(lv_filespec,
					last_slash_pos + 1,
					slash_pos - last_slash_pos - 1);
				lv_path := substr(lpad(' ',4)||lv_dir3, 1, 50);
				write_record;
			elsif nth = 4 then
				lv_dir4 := substr(lv_filespec,
					last_slash_pos + 1,
					slash_pos - last_slash_pos - 1);
				lv_path := substr(lpad(' ',6)||lv_dir4, 1, 50);
				write_record;
			elsif nth = 5 then
				lv_dir5 := substr(lv_filespec,
					last_slash_pos + 1,
					slash_pos - last_slash_pos - 1);
				lv_path := substr(lpad(' ',8)||lv_dir5, 1, 50);
				write_record;
			elsif nth = 6 then
				lv_dir6 := substr(lv_filespec,
					last_slash_pos + 1,
					slash_pos - last_slash_pos - 1);
				lv_path := substr(lpad(' ',10)||lv_dir6, 1, 50);
				write_record;
			elsif nth = 7 then
				lv_dir7 := substr(lv_filespec,
					last_slash_pos + 1,
					slash_pos - last_slash_pos - 1);
				lv_path := substr(lpad(' ',12)||lv_dir7, 1, 50);
				write_record;
			elsif nth = 8 then
				lv_dir8 := substr(lv_filespec,
					last_slash_pos + 1,
					slash_pos - last_slash_pos - 1);
				lv_path := substr(lpad(' ',14)||lv_dir8, 1, 50);
				write_record;
			elsif nth = 9 then
				lv_dir9 := substr(lv_filespec,
					last_slash_pos + 1,
					slash_pos - last_slash_pos - 1);
				lv_path := substr(lpad(' ',16)||lv_dir9, 1, 50);
				write_record;
			elsif nth = 10 then
				lv_dir10 := substr(lv_filespec,
					last_slash_pos + 1,
					slash_pos - last_slash_pos - 1);
				lv_path := substr(lpad(' ',18)||lv_dir10, 1,50);
				write_record;
			elsif nth = 11 then
				lv_dir11 := substr(lv_filespec,
					last_slash_pos + 1,
					slash_pos - last_slash_pos - 1);
				lv_path := substr(lpad(' ',20)||lv_dir11, 1,50);
				write_record;
			elsif nth = 12 then
				lv_dir12 := substr(lv_filespec,
					last_slash_pos + 1,
					slash_pos - last_slash_pos - 1);
				lv_path := substr(lpad(' ',22)||lv_dir12, 1,50);
				write_record;
			elsif nth = 13 then
				lv_dir13 := substr(lv_filespec,
					last_slash_pos + 1,
					slash_pos - last_slash_pos - 1);
				lv_path := substr(lpad(' ',24)||lv_dir13, 1,50);
				write_record;
			elsif nth = 14 then
				lv_dir14 := substr(lv_filespec,
					last_slash_pos + 1,
					slash_pos - last_slash_pos - 1);
				lv_path := substr(lpad(' ',26)||lv_dir14, 1,50);
				write_record;
			elsif nth = 15 then
				lv_dir15 := substr(lv_filespec,
					last_slash_pos + 1,
					slash_pos - last_slash_pos - 1);
				lv_path := substr(lpad(' ',28)||lv_dir15, 1,50);
				write_record;
			elsif nth = 16 then
				lv_dir16 := substr(lv_filespec,
					last_slash_pos + 1,
					slash_pos - last_slash_pos - 1);
				lv_path := substr(lpad(' ',30)||lv_dir16, 1,50);
				write_record;
			end if;
			last_slash_pos := slash_pos;
			nth := nth + 1;
			if nth < 17 then
				slash_pos := instr(lv_filespec, '/', 2, nth);
			else
				slash_pos := 0;
			end if;
		end loop;
		is_path := 0;
		lv_path := substr(lpad(' ',20) ||
			substr(lv_filespec, last_slash_pos + 1), 1,50);
		write_record;
	end loop;
	close locate_cur;
	-- Eliminate the duplicate paths from the report, and create totals
	grandtotal := 0;
	linenum := 0;
	prev_dir1 := ' ';
	prev_dir2 := ' ';
	prev_dir3 := ' ';
	prev_dir4 := ' ';
	prev_dir5 := ' ';
	prev_dir6 := ' ';
	prev_dir7 := ' ';
	prev_dir8 := ' ';
	prev_dir9 := ' ';
	prev_dir10 := ' ';
	prev_dir11 := ' ';
	prev_dir12 := ' ';
	prev_dir13 := ' ';
	prev_dir14 := ' ';
	prev_dir15 := ' ';
	prev_dir16 := ' ';
	open locate_cur2;
	loop
		fetch locate_cur2 into
			lv_dir1,
			lv_dir2,
			lv_dir3,
			lv_dir4,
			lv_dir5,
			lv_dir6,
			lv_dir7,
			lv_dir8,
			lv_dir9,
			lv_dir10,
			lv_dir11,
			lv_dir12,
			lv_dir13,
			lv_dir14,
			lv_dir15,
			lv_dir16,
			lv_path,
			lv_sid,
			lv_type,
			lv_tablespace,
			lv_mbytes,
			lv_status;
		exit when locate_cur2%NOTFOUND;
		-- See if new root-level directory read in
		if lv_dir1 != prev_dir1 then
			-- Store total of any previous root-level directory
			if prev_dir1 != ' ' then
				linenum := linenum + 1;
				if length(prev_dir1) < 24 then
					insert into location_locate_temp2
						values (
						linenum,
						lpad('> Subtotal for ' ||
							prev_dir1, 40, '='),
						'========',
						'====',
						'Subtotal:',
						subtotal,
						'=====');
				else
					insert into location_locate_temp2
						values (
						linenum,
						substr('  ====> ' || prev_dir1,
							1, 50),
						'========',
						'====',
						'Subtotal:',
						subtotal,
						'=====');
				end if;
				linenum := linenum + 1;
				insert into location_locate_temp2 values (
					linenum,
					' ',
					' ',
					' ',
					' ',
					0,
					' ');
			end if;
			subtotal := 0;
		end if;
		subtotal := subtotal + lv_mbytes;
		grandtotal := grandtotal + lv_mbytes;
		-- See if identical path read in
		if lv_dir1 != prev_dir1 or lv_dir2 != prev_dir2 or 
			lv_dir3 != prev_dir3 or lv_dir4 != prev_dir4 or 
			lv_dir5 != prev_dir5 or lv_dir6 != prev_dir6 or 
			lv_dir7 != prev_dir7 or lv_dir8 != prev_dir8 or 
			lv_dir9 != prev_dir9 or lv_dir10 != prev_dir10 or 
			lv_dir11 != prev_dir11 or lv_dir12 != prev_dir12 or 
			lv_dir13 != prev_dir13 or lv_dir14 != prev_dir14 or 
			lv_dir15 != prev_dir15 or lv_dir16 != prev_dir16 or
			lv_sid != ' '
		then
			linenum := linenum + 1;
			insert into location_locate_temp2 values (
				linenum,
				lv_path,
				lv_sid,
				lv_type,
				lv_tablespace,
				lv_mbytes,
				lv_status);
			prev_dir1 := lv_dir1;
			prev_dir2 := lv_dir2;
			prev_dir3 := lv_dir3;
			prev_dir4 := lv_dir4;
			prev_dir5 := lv_dir5;
			prev_dir6 := lv_dir6;
			prev_dir7 := lv_dir7;
			prev_dir8 := lv_dir8;
			prev_dir9 := lv_dir9;
			prev_dir10 := lv_dir10;
			prev_dir11 := lv_dir11;
			prev_dir12 := lv_dir12;
			prev_dir13 := lv_dir13;
			prev_dir14 := lv_dir14;
			prev_dir15 := lv_dir15;
			prev_dir16 := lv_dir16;
		end if;
	end loop;
	close locate_cur2;
	-- Store total of any previous root-level directory and grand total
	if prev_dir1 != ' ' then
		linenum := linenum + 1;
		if length(prev_dir1) < 24 then
			insert into location_locate_temp2 values (
				linenum,
				lpad('> Subtotal for ' || prev_dir1, 40, '='),
				'========',
				'====',
				'Subtotal:',
				subtotal,
				'=====');
		else
			insert into location_locate_temp2 values (
				linenum,
				substr('  ====> ' || prev_dir1, 1, 50),
				'========',
				'====',
				'Subtotal:',
				subtotal,
				'=====');
		end if;
		linenum := linenum + 1;
		insert into location_locate_temp2 values (
			linenum,
			' ',
			' ',
			' ',
			' ',
			0,
			' ');
		linenum := linenum + 1;
		insert into location_locate_temp2 values (
			linenum,
			'****************************************',
			'********',
			'****',
			'Grand Total:',
			grandtotal,
			'*****');
	end if;
end;
/

set echo off
set feedback off
set linesize 80
set pagesize 9999
set termout off
set verify off
rem
rem Calculate date for report
rem
column now noprint new_value today
select to_char(sysdate, 'MM/DD/YY') now from dual;
rem
rem Create the report
rem
ttitle left &today center 'Oracle database file locations, by directory' -
	format 999 right "Page" sql.pno skip 2
column path format A40 heading 'Path / File Name'
column sid format A8 heading 'Oracle| SID '
column type format A4 heading 'Type'
column tablespace format A12 heading 'Tablespace'
column mbytes format A6 heading ' MB | on |Disk'
column status format A5 heading 'Stat'
spool location.lis
select path, sid, type, tablespace,
	decode(substr(tablespace,1,4),'Ctrl','     0','Ifil','     0',
	'Grp ', to_char(mbytes, '99999'), to_char(mbytes, '99999B')) mbytes,
	status
	from location_locate_temp2
	order by lineno;
spool off
set termout off
drop table location_all_db_temp;
drop table location_locate_temp;
drop table location_locate_temp2;
exit
