/* QUOTAS.SQL */
/* Prints a report of all user account quotas defined in the database */
set pagesize 66
ttitle skip 2 center 'QUOTAS - Database User Quotas' skip 2
column username format A14
column tablespace_name format A15 heading "Tablespace|   Name"
column MB format 99999 heading "MB |Quota"
column MMB format A9 heading "   Max MB|   Quota"
break on username
spool quotas.lst
set termout off
select username, tablespace_name, bytes / 1024 "MB",
decode(max_bytes,-1,'unlimited', rpad(max_bytes / 1024, 9)) "MMB"
from dba_ts_quotas
order by 1, 2;
spool off
set termout on
/* prompt Created quotas.lst for your viewing pleasure... */
exit
