rem $TOOLS/dbo_sql.sql
rem
rem Prints a report of all the sql statements currently being executed for
rem all current users in the current database
rem
rem Requires that $DBA/dbosqli.sql first be executed to create the required
rem view and synonym.
rem
rem Last Change 12/04/96 by Brian Lomasky
rem
set termout off
set heading off
column adate new_value now
column dbname1 new_value dbname noprint
select to_char(sysdate, 'MM/DD/YY') adate, name dbname1 from v$database;
set termout on
set heading on
set pagesize 66
ttitle left &now center 'DBO_SQL - SQL Text for database ' &&dbname ' users' -
skip 2
set concat +
spool dbo_sql.lst
set concat .
set termout off
column username format a6 heading "Oracle|User"
column sid noprint
column piece noprint
column osuser format a8 heading "O/S  |Username"
column sql_text format a64 heading "SQL Text"
break on sid on username on osuser
select username, sid, piece, osuser, sql_text
from dbo_sql_text
order by 1, 2, 3;
spool off
set termout on
exit
