------------------------------------------------------------------------------
-- free.sql  
--
-- This SQL Plus script lists freespace by tablespace
------------------------------------------------------------------------------

set pagesize 66
ttitle skip 2 center 'FREE - Free space by Tablespace' skip 2
column dummy noprint
column  pct_used format 999.9       heading "%|Used" 
column  name    format a16      heading "Tablespace Name" 
column  bytes   format 9,999,999,999,999    heading "Total Bytes" 
column  used    format 99,999,999,999   heading "Used" 
column  free    format 999,999,999,999  heading "Free" 
break   on report 
compute sum of bytes on report 
compute sum of free on report 
compute sum of used on report 
spool free.lst
set termout off
select a.tablespace_name                                              name,
	   b.tablespace_name                                              dummy,
	   sum(b.bytes)/count( distinct a.file_id||'.'||a.block_id )      bytes,
	   sum(b.bytes)/count( distinct a.file_id||'.'||a.block_id ) -
	   sum(a.bytes)/count( distinct b.file_id )			  used,
	   sum(a.bytes)/count( distinct b.file_id )                       free,
	   100 * ( (sum(b.bytes)/count( distinct a.file_id||'.'||a.block_id )) -
			   (sum(a.bytes)/count( distinct b.file_id ) )) /
	   (sum(b.bytes)/count( distinct a.file_id||'.'||a.block_id )) pct_used
from sys.dba_free_space a, sys.dba_data_files b
where a.tablespace_name = b.tablespace_name
group by a.tablespace_name, b.tablespace_name;
spool off
set termout on
/* prompt Created free.lst for your viewing pleasure... */
exit
