rem INSTANCE.SQL
rem
rem Displays the start date and time of the current instance.
rem
rem Must be executed by SYS username.
rem
rem Created 08/12/96 by Brian Lomasky
rem
COL ISD FORMAT A17 HEADING 'Instance Startup|Date and Time'
SELECT TO_CHAR(TO_DATE(A.VALUE, 'J'), 'MM/DD/YY') || ' ' ||
	LTRIM(TO_CHAR(B.VALUE / 3600, '00')) || ':' ||
	LTRIM(TO_CHAR((B.VALUE - 3600 * FLOOR(B.VALUE / 3600)) / 60, '00')) ||
	':' || LTRIM(TO_CHAR((B.VALUE - 60 * FLOOR(B.VALUE / 60)), '00')) ISD
FROM V$INSTANCE A, V$INSTANCE B
WHERE A.KEY = 'STARTUP TIME - JULIAN' AND B.KEY = 'STARTUP TIME - SECONDS';
EXIT
