rem $DBA/invalid.sql
rem Lists all invalid objects for a database.
rem
set verify off
set pagesize 66
set feedback off
column owner format A15
column object_name format A30 heading 'Object'
column object_id format 999999 heading "Id#"
column object_type format A15
column status format A8
ttitle left 'INVALID - Invalid Objects for '_NAME'         '_DATE skip 2
spool invalid.lst
set termout off
select owner, object_name, object_id, object_type, status
from dba_objects where status != 'VALID';
spool off
rem
rem Create script which can be used to recompile all of the invalid objects
rem
ttitle off
set concat +
spool invalid.tmp
set concat .
set feedback off
set heading off
set pagesize 999
set verify off

select distinct 'sqlplus '||owner||'/'||owner||'<<EOF'||chr(10)||
'prompt Compiling '||owner||' objects...'||chr(10)||
'execute dbms_utility.compile_schema('||chr(39)||owner||chr(39)||');'||
chr(10)||'show err;'||chr(10)||'quit'||chr(10)||'EOF'
from dba_objects where status != 'VALID' and object_type != 'VIEW';

select 'sqlplus '||owner||'/'||owner||'<<EOF'||chr(10)||
'prompt Compiling '||owner||' views...'||chr(10)||
'alter view '||object_name||' compile;'||chr(10)||
'show errors view '||object_name||';'||chr(10)||'quit'||chr(10)||'EOF'
from dba_objects where status != 'VALID' and object_type = 'VIEW';

spool off
set termout on
exit
