/* ==================================================== */
/* Copyright(c) 1996,1997 by SAVANT Corp.               */
/* All rights reserved.                                 */
/* ==================================================== */
REM ***************************************************
REM Revision History:
REM
REM 05/29/97 added minextents 1           [JMB]
REM 00/00/96 Original creation:           [JMB]
REM ***************************************************

CREATE CLUSTER &&qdba..q$detl_log(collect_seq  INTEGER)
   PCTFREE 5
   PCTUSED 80
   INITRANS 3
   TABLESPACE &&qtablespace
   SIZE 900
   INDEX
   STORAGE 
      (INITIAL    512K 
       NEXT       128K
       MINEXTENTS 1 
       PCTINCREASE 0);

CREATE INDEX &&qdba..q$dtel_log_CK ON CLUSTER &&qdba..q$detl_log
   TABLESPACE &&qtablespace
   STORAGE 
      (INITIAL    16K 
       NEXT       8K
       MINEXTENTS 1 
       PCTINCREASE 0);


CREATE TABLE &&qdba..q$dicache_detl 
   (collect_seq      INTEGER NOT NULL
   ,cache_id         NUMBER(5,2)
   ,cache_name       VARCHAR2(32)
   ,usage            INTEGER
   ,gets             INTEGER
   ,getmisses        INTEGER
   )
   PCTFREE 5
   PCTUSED 80
   STORAGE 
      (INITIAL    128K 
       NEXT       64K
       MINEXTENTS 1 
       PCTINCREASE 0)
TABLESPACE &&qtablespace
/*   CLUSTER &&qdba..q$detl_log (collect_seq) */ ;


CREATE TABLE &&qdba..q$libcache_detl
   (collect_seq      INTEGER NOT NULL
   ,cache_namespace  VARCHAR2(15)
   ,shpool_mem_KB    NUMBER
   ,gets             INTEGER
   ,gethits          INTEGER
   ,pins             INTEGER
   ,pinhits          INTEGER
   ,reloads          INTEGER
   )
   PCTFREE 5
   PCTUSED 80
   STORAGE 
      (INITIAL     64K 
       NEXT        32K 
       MINEXTENTS  1
       PCTINCREASE 0)
TABLESPACE &&qtablespace
/*   CLUSTER &&qdba..q$detl_log (collect_seq) */;


CREATE TABLE &&qdba..q$latchstat_detl
   (collect_seq      INTEGER NOT NULL
   ,latch_id         INTEGER
   ,latch_name       VARCHAR2(64)
   ,gets             INTEGER
   ,misses           INTEGER
   ,sleeps           INTEGER
   ,immed_gets       INTEGER
   ,immed_misses     INTEGER
   )
   PCTFREE 5
   PCTUSED 80
   STORAGE 
      (INITIAL     256K 
       NEXT        128K
       MINEXTENTS  1 
       PCTINCREASE 0)
TABLESPACE &&qtablespace
/*   CLUSTER &&qdba..q$detl_log (collect_seq) */;


CREATE TABLE &&qdba..q$sessionwait_detl
   (collect_seq   INTEGER NOT NULL
   ,sess_id       INTEGER
   ,username      VARCHAR2(30)
   ,wait_event    VARCHAR2(64)
   ,wait_time     INTEGER
   ,wait_state    VARCHAR2(30)
   )
   PCTFREE 5
   PCTUSED 80
   STORAGE 
      (INITIAL    128K 
       NEXT       64K
       MINEXTENTS 1 
       PCTINCREASE 0)
TABLESPACE &&qtablespace
/*   CLUSTER &&qdba..q$detl_log (collect_seq) */;


CREATE TABLE &&qdba..q$IOwaits_detl
   (collect_seq      INTEGER NOT NULL
   ,event_name       VARCHAR2(64)
   ,total_waits      NUMBER
   ,total_waittime   NUMBER
   )
   PCTFREE 5
   PCTUSED 80
   STORAGE 
      (INITIAL    64K 
       NEXT       32K
       MINEXTENTS 1 
       PCTINCREASE 0)
TABLESPACE &&qtablespace
/*   CLUSTER &&qdba..q$detl_log (collect_seq) */;


CREATE TABLE &&qdba..q$segfail_detl
   (collect_seq      INTEGER NOT NULL
   ,seg_schema    VARCHAR2(30)
   ,seg_name      VARCHAR2(30)
   ,seg_type      VARCHAR2(30)
   ,seg_tbsname   VARCHAR2(30)
   ,seg_failreason VARCHAR2(10)
   ,seg_faildate  VARCHAR2(30)
   ,seg_failmin   INTEGER
   )
/* TABLESPACE &&qtablespace */
 CLUSTER &&qdba..q$detl_log (collect_seq);


CREATE TABLE &&qdba..q$MTSdisp_detl
   (collect_seq      INTEGER NOT NULL
   ,disp_name     VARCHAR2(5)
   ,disp_idle     INTEGER
   ,disp_busy     INTEGER
   )
/* TABLESPACE &&qtablespace  */
  CLUSTER &&qdba..q$detl_log (collect_seq);


CREATE TABLE &&qdba..q$MTSserv_detl
   (collect_seq      INTEGER NOT NULL
   ,serv_name     VARCHAR2(5)
   ,serv_idle     INTEGER
   ,serv_busy     INTEGER
   )
/* TABLESPACE &&qtablespace  */
  CLUSTER &&qdba..q$detl_log (collect_seq);

CREATE TABLE &&qdba..q$instat_detl
   (collect_seq         INTEGER NOT NULL
   ,collect_sysdate     DATE
   ,collect_hsecs       INTEGER
/*  ----------------------------- */ 
/*  InstID_rec expanded           */
/*  ----------------------------- */
   ,db_name             VARCHAR2(20)
   ,db_domain           VARCHAR2(255)
   ,O7kernel_rel        VARCHAR2(20)
   ,inst_start_date     DATE
   ,archivelog_mode     VARCHAR2(20)
   ,log_sequence        INTEGER
   ,tot_size_KB         NUMBER
   ,tot_free_KB         NUMBER
/* ------------------------------ */
/*     InstTF_rec expanded        */
/* ------------------------------ */
   ,snapshots_exist     VARCHAR2(5)
   ,dblinks_exist       VARCHAR2(5)
   ,open_dblinks_exist  VARCHAR2(5)
   ,Xlock_waits_exist   VARCHAR2(5)
   ,tempsegs_exist      VARCHAR2(5)
   ,bgproc_exec_stat    VARCHAR2(10)
/* ------------------------------ */
/*    IOstats_rec  expanded       */
/* ------------------------------ */
   ,dbfile_waits        INTEGER
   ,dbfile_waittime     INTEGER
   ,lgfile_waits        INTEGER
   ,lgfile_waittime     INTEGER
   ,dbf_physrds         INTEGER
   ,dbf_physwrts        INTEGER
   ,dbf_physblksrd      INTEGER
   ,dbf_physblkswrt     INTEGER
   ,IOskew              NUMBER
   ,IOstat_secs         INTEGER
   ,IOstat_date         DATE
/* ------------------------------ */
/*   SGAactiv_rec expanded        */
/* ------------------------------ */
   ,buffer_busy_waits   INTEGER
   ,buffer_busy_waittime INTEGER
   ,latch_gets          INTEGER
   ,latch_misses        INTEGER
   ,latch_sleeps        INTEGER
   ,latch_imm_gets      INTEGER
   ,latch_imm_misses    INTEGER
   ,dicache_gets        INTEGER
   ,dicache_getmisses   INTEGER
   ,libcache_gets       INTEGER
   ,libcache_gethits    INTEGER
   ,libcache_pins       INTEGER
   ,libcache_pinhits    INTEGER
   ,libcache_reloads    INTEGER
   ,rbs_gets            INTEGER
   ,rbs_waits           INTEGER
   ,rbs_xacts           INTEGER
   ,crit_tempseg_extents INTEGER
   ,crit_tempseg_maxexts INTEGER
   ,crit_rbseg_extents  INTEGER
   ,crit_rbseg_maxexts  INTEGER
   ,active_tempsegs     INTEGER
/* ------------------------------ */
/*  SGAdata_rec expanded          */
/* ------------------------------ */
   ,SGA_size_KB         NUMBER
   ,fixed_area_KB       NUMBER
   ,db_buffer_KB        NUMBER
   ,db_buffer_free_KB   NUMBER
   ,redo_buffer_KB      NUMBER
   ,shpool_KB           NUMBER
   ,shpool_free_KB      NUMBER
   ,shpool_maxfree_KB   NUMBER
   ,shpool_free_exts    INTEGER
   ,dictionary_cache_KB NUMBER
   ,library_cache_KB    NUMBER
   ,SQLarea_KB          NUMBER
   ,sess_MTS_KB         NUMBER
/* ------------------------------ */
/*    sysstat_rec expanded        */
/* ------------------------------ */
   ,logons              INTEGER
   ,logons_cum          INTEGER
   ,open_cursors        INTEGER
   ,open_cursors_cum    INTEGER
   ,commits             INTEGER
   ,db_block_gets       INTEGER
   ,consistent_gets     INTEGER
   ,logical_reads       INTEGER
   ,physical_reads      INTEGER
   ,enqueue_requests    INTEGER
   ,enqueue_timeouts    INTEGER
   ,user_calls          INTEGER
   ,parse_count         INTEGER
   ,execute_count       INTEGER
   ,recursive_calls     INTEGER
   ,sorts_disk          INTEGER
   ,sorts_memory        INTEGER
   ,table_scan_rows_gotten INTEGER
   ,table_fetch_rowid   INTEGER
   ,table_scans_short   INTEGER
   ,table_scans_long    INTEGER
   ,table_fetch_cont_row INTEGER
   ,redo_size           INTEGER
   ,redo_log_space_req  INTEGER
   ,redo_buf_alloc_retries INTEGER
   ,redo_writes         INTEGER
   ,redo_log_space_wait_time INTEGER
   ,redo_entries        INTEGER
   ,redo_blocks_written INTEGER
   ,summed_dirty_queue_len INTEGER
   ,write_requests      INTEGER
   ,dirty_buf_inspected INTEGER
   ,DBWR_make_free_req  INTEGER
   ,DBWR_free_buf_found INTEGER
   ,sess_uga_memory     INTEGER
   ,sess_pga_memory     INTEGER
   ,SQLnet_rndtrips     INTEGER
   ,SQLnetKB_to_client  NUMBER
   ,SQLnetKB_from_client NUMBER
   ,dblink_rndtrips     INTEGER
   ,dblinkKB_to_client  NUMBER
   ,dblinkKB_from_client NUMBER
   ,sysstat_secs        INTEGER
   ,sysstat_date        DATE
/* ------------------------------ */
/*    MTSdata_rec expanded        */
/* ------------------------------ */
   ,conn_dedicated      INTEGER
   ,conn_shared         INTEGER
   ,MTS_dispatchers     INTEGER
   ,MTS_servers         INTEGER
   ,disp_busy_hsec      INTEGER
   ,disp_idle_hsec      INTEGER
   ,disp_waittime_hsec  INTEGER
   ,disp_totalqueue     INTEGER
   ,serv_busy_hsec      INTEGER
   ,serv_idle_hsec      INTEGER
   ,serv_waittime_hsec  INTEGER
   ,serv_totalqueue     INTEGER
   )
   PCTFREE 5
   PCTUSED 80
   STORAGE 
      (INITIAL    256K 
       NEXT       128K
       MINEXTENTS 1 
       PCTINCREASE 0)
   TABLESPACE &&qtablespace
/*   CLUSTER &&qdba..q$detl_log (collect_seq) */;

CREATE INDEX &&qdba..q$instat_detl_AK ON &&qdba..q$instat_detl
   (collect_sysdate)
   TABLESPACE &&qtablespace
   STORAGE 
      (INITIAL    16K 
       NEXT       8K
       MINEXTENTS 1
       PCTINCREASE 0);


