REM *****************************************************
REM Drops all Q Database Objects and the QDBA user
REM *****************************************************
REM ******************************************************
REM Revision history:
REM
REM 11/12/97: added Q_USER_ROLE                      [JMB]
REM 10/29/97: added Q$ORA                            [JMB]
REM 10/27/97: added Q$INSTANCE                       [JMB]
REM 06/30/97: added Q$ACCESS                         [JMB]
REM 06/13/97: added Q$LOCKC                          [JMB]
REM 06/05/97: added Q$LOCK                           [JMB]
REM 00/00/96: original creation                      [JMB]
REM ******************************************************

set verify off
set serveroutput on size 1000000

undefine qdba
define qdba='QDBA'
REM ************** hardcoded QDBA for v1.0 beta ******************
REM ACCEPT qdba CHAR prompt 'Enter Q dba install account to drop:'
REM **************************************************************

var return_code NUMBER
set feedback off
DECLARE 
   jobno       INTEGER;
BEGIN
   qdba.q$bgproc.kill_driver;
   --
   sys.dbms_lock.sleep(5);
   --
   :return_code := 0;
   --
   select job 
     into jobno
     from dba_jobs
    where UPPER(what) like '%Q$BGPROC.DRIVER%';
   --
   IF jobno IS NOT NULL
   THEN
      dbms_output.put_line('-------------------------------------------------------------');
      dbms_output.put_line('ERROR CONDITION');
      dbms_output.put_line('The Q Diagnostic Engine must be removed from the Job Queue before');
      dbms_output.put_line('dropping Q.  Please use the stop_driver procedure and re-execute ');
      dbms_output.put_line('QDROP');
      dbms_output.put_line('-------------------------------------------------------------');
      dbms_output.put_line('QDROP will exit after the prompt');
      :return_code := 1;
   END IF;
EXCEPTION
   WHEN NO_DATA_FOUND 
      THEN 
         :return_code :=0;
         dbms_output.put_line('OK, Q Engine not running, drop will continue after prompt.');   
   WHEN OTHERS THEN :return_code := 99;
END;
/

pause press Enter to continue...

WHENEVER SQLERROR EXIT
BEGIN
   IF :return_code > 0
   THEN
      raise_application_error(-20000, 'exiting QDROP...');
   END IF;
END;
/
WHENEVER SQLERROR CONTINUE

set feedback on

rem drop sys views
rem
prompt Droppinng SYS views for Q

DROP VIEW sys.q$latch;
DROP VIEW sys.q$bh;
DROP VIEW sys.q$spfree;
DROP VIEW sys.q$ksppi;
DROP VIEW sys.q$lock;
DROP VIEW sys.q$lockc;

prompt dropping &&qdba views

rem drop QDBA views
DROP VIEW &&qdba..q$circuit;
DROP VIEW &&qdba..q$objchsum;
DROP VIEW &&qdba..q$tbsseg;
DROP VIEW &&qdba..q$filfree;
DROP VIEW &&qdba..q$avg_io;
DROP VIEW &&qdba..q$lckcon; 
DROP VIEW &&qdba..q$sesstat;
DROP VIEW &&qdba..q$sesstot;
DROP VIEW &&qdba..q$sessio;
DROP VIEW &&qdba..q$tbsfree;
DROP VIEW &&qdba..q$tbsblks;
DROP VIEW &&qdba..q$lckusr; 
DROP VIEW &&qdba..q$instat_dlta;
DROP VIEW &&qdba..q$session;
DROP VIEW &&qdba..q$access;
DROP VIEW &&qdba..q$instance;

prompt
prompt Dropping &&qdba packages
prompt This can take up to 10 minutes
prompt
prompt Please be patient...
prompt

rem drop packages
DROP PACKAGE &&qdba..q$bgproc;
DROP PACKAGE &&qdba..q$instat;
DROP PACKAGE &&qdba..q$cvar;
DROP PACKAGE &&qdba..q$sess;
DROP PACKAGE &&qdba..q$inst2;
DROP PACKAGE &&qdba..q$trend;
DROP PACKAGE &&qdba..q$space;
DROP PACKAGE &&qdba..q$decl;
DROP PACKAGE &&qdba..q$repl;
DROP PACKAGE &&qdba..q$detl;
DROP PACKAGE &&qdba..q$ora;

prompt Dropping &&qdba user's tables

rem drop tables and sequence
DROP TABLE &&qdba..q$plan_table;
DROP TABLE &&qdba..q$bgp_debug;
DROP TABLE &&qdba..q$instat_log;
DROP TABLE &&qdba..q$seg;
DROP TABLE &&qdba..q$segwatch;
DROP TABLE &&qdba..q$bgp_config;

rem *** drop the replay detail tables/cluster
DROP TABLE &&qdba..q$instat_detl;
DROP TABLE &&qdba..q$segfail_detl;
DROP TABLE &&qdba..q$MTSdisp_detl;
DROP TABLE &&qdba..q$MTSserv_detl;

DROP TABLE &&qdba..q$IOwaits_detl;
DROP TABLE &&qdba..q$sessionwait_detl;
DROP TABLE &&qdba..q$latchstat_detl;
DROP TABLE &&qdba..q$libcache_detl;
DROP TABLE &&qdba..q$dicache_detl;

DROP CLUSTER &&qdba..q$detl_log;
DROP SEQUENCE &&qdba..q$instat_seq;

rem drop public synonym
DROP PUBLIC SYNONYM Q$PLAN_TABLE;

rem ** QDBA user will not be dropped
rem ** if any objects left 

DROP USER &&qdba;

DROP ROLE Q_USER_ROLE;

set verify on
