/* ==================================================== */
/* Copyright(c) 1996,1997 by SAVANT Corp.               */
/* All rights reserved.                                 */
/* ==================================================== */
REM ***************************************************
REM Revision History:
REM
REM 01/27/98: added last_obj and last_objtype to   [JMB]
REM           Q$BGP_CONFIG for new segment tracking 
REM 11/24/97: added PRIMARY KEY constraint to id col [JMB]
REM           of q$bgp_config
REM 11/24/97: modified insert of q$bgp_config rows [JMB]
REM           to work if script re-executed
REM 06/19/97: added obj# to q$seg                  [JMB]
REM 06/19/97: moved watchcount and last_watch_date [JMB]
REM           columns to q$seg table
REM 06/19/97: added last_watch_date to q$segwatch  [JMB]
REM 06/19/97: defaulting to TEMP_SEGS for segwatch [JMB]
REM 06/17/97: added file# and block# to q$seg and  [JMB]
REM           q$segwatch tables
REM 06/16/97: modified q$seg_PK column order for   [JMB]
REM           performance of tempseg processing
REM 06/14/97: added names for CHECK constraints    [JMB]
REM           on q$bgp_config table
REM 06/14/97: modified segwatch of q$bgp_config    [JMB]
REM           to accept TEMP_SEGS, ALL_SEGS, or
REM           NO_SEGWATCH
REM 05/29/97: added minextents 1                   [JMB]
REM 00/00/96: original creation:                   [JMB]
REM ***************************************************

/* ---------------------------------------------------- */
/* plan_table for EXPLAIN output                        */
/* ---------------------------------------------------- */
CREATE TABLE &&qdba..q$plan_table 
   (statement_id  VARCHAR2(30)
   ,timestamp     DATE
   ,remarks       VARCHAR2(80)
   ,operation     VARCHAR2(30)
   ,options       VARCHAR2(30)
   ,object_node   VARCHAR2(128)
   ,object_owner  VARCHAR2(30)
   ,object_name   VARCHAR2(30)
   ,object_instance  NUMERIC
   ,object_type   VARCHAR2(30)
   ,optimizer     VARCHAR2(255)
   ,search_columns   NUMERIC
   ,id            NUMERIC
   ,parent_id     NUMERIC
   ,position      NUMERIC
   ,cost          NUMERIC
   ,cardinality   NUMERIC
   ,bytes         NUMERIC
   ,other_tag     VARCHAR2(255)
   ,other         LONG
   )
TABLESPACE &&qtablespace
PCTFREE 5
STORAGE (INITIAL 	   64K 
	      NEXT 		   16K
         MINEXTENTS  1 
	      PCTINCREASE 0);

CREATE PUBLIC SYNONYM q$plan_table FOR &&qdba..q$plan_table;


/* ---------------------------------------------------- */
/* q$bgp_debug table holds debug info for q$bgproc      */
/* ---------------------------------------------------- */


CREATE TABLE &&qdba..q$bgp_debug
   (message_date     DATE
   ,message          VARCHAR2(255)
   )
TABLESPACE &&qtablespace
PCTFREE	5
STORAGE (INITIAL 	   32K 
	      NEXT 		   32K 
         MINEXTENTS  1
	      PCTINCREASE 0);



CREATE TABLE &&qdba..q$instat_log
      (/* db_name                          VARCHAR2(20) NOT NULL */
       collect_seq                      INTEGER NOT NULL
      ,collect_sysdate                  DATE NOT NULL
      ,collect_hsecs                    INTEGER NOT NULL
      ,inst_start_date                  DATE NOT NULL
      ,log_sequence                     INTEGER NOT NULL           
      ,logons                           INTEGER NOT NULL         
      ,logons_cum                       INTEGER NOT NULL         
      ,open_cursors                     INTEGER NOT NULL       
      ,open_cursors_cum                 INTEGER NOT NULL   
      ,commits                          INTEGER NOT NULL            
      ,db_block_gets                    INTEGER NOT NULL             
      ,consistent_gets                  INTEGER NOT NULL            
      ,physical_reads                   INTEGER NOT NULL   
      ,buffer_busy_waits                INTEGER NOT NULL       
      ,buffer_busy_waittime             INTEGER NOT NULL
      ,enqueue_requests                 INTEGER NOT NULL         
      ,enqueue_timeouts                 INTEGER NOT NULL        
      ,redo_size                        INTEGER NOT NULL          
      ,user_calls                       INTEGER NOT NULL        
      ,parse_count                      INTEGER NOT NULL        
      ,execute_count                    INTEGER NOT NULL       
      ,recursive_calls                  INTEGER NOT NULL        
      ,sorts_disk                       INTEGER NOT NULL       
      ,sorts_memory                     INTEGER NOT NULL     
      ,table_scan_rows_gotten           INTEGER NOT NULL      
      ,table_fetch_rowid                INTEGER NOT NULL     
      ,table_scans_short                INTEGER NOT NULL     
      ,table_scans_long                 INTEGER NOT NULL   
      ,table_fetch_cont_row             INTEGER NOT NULL   
      ,rbs_waits                        INTEGER NOT NULL
      ,rbs_gets                         INTEGER NOT NULL
      ,rbs_xacts                        INTEGER NOT NULL
      ,latch_gets                       INTEGER NOT NULL
      ,latch_misses                     INTEGER NOT NULL
      ,latch_sleeps                     INTEGER NOT NULL
      ,latch_imm_gets                   INTEGER NOT NULL
      ,dbfile_waits                     INTEGER NOT NULL
      ,dbfile_waittime                  INTEGER NOT NULL
      ,lgfile_waits                     INTEGER NOT NULL
      ,lgfile_waittime                  INTEGER NOT NULL
      ,dicache_gets                     INTEGER NOT NULL
      ,dicache_getmisses                INTEGER NOT NULL
      ,libcache_gets                    INTEGER NOT NULL
      ,libcache_gethits                 INTEGER NOT NULL
      ,libcache_pins                    INTEGER NOT NULL
      ,libcache_pinhits                 INTEGER NOT NULL 
      ,libcache_reloads                 INTEGER NOT NULL
      ,shpool_free_KB                   NUMBER(8,1) NOT NULL
      ,shpool_maxfree_KB                NUMBER(8,1) NOT NULL    
      ,shpool_free_exts                 INTEGER NOT NULL  
      ,IOskew                           NUMBER NOT NULL
      ,dbf_physrds                      INTEGER NOT NULL
      ,dbf_physwrts                     INTEGER NOT NULL
      ,active_tempsegs                  INTEGER NOT NULL
      ,disp_busy_hsec                   INTEGER NOT NULL
      ,disp_idle_hsec                   INTEGER NOT NULL
      ,disp_waittime_hsec               INTEGER NOT NULL
      ,disp_totalqueue                  INTEGER NOT NULL
      ,serv_busy_hsec                   INTEGER NOT NULL
      ,serv_idle_hsec                   INTEGER NOT NULL
      ,serv_waittime_hsec               INTEGER NOT NULL
      ,serv_totalqueue                  INTEGER NOT NULL
      ,trend_hh24                       CHAR(2) NOT NULL
      ,trend_day                        CHAR(3) NOT NULL
   )
TABLESPACE &&qtablespace
PCTFREE 5
STORAGE (INITIAL 	   512K 
         NEXT 	   	512K
         MINEXTENTS  1 
         PCTINCREASE 0);


CREATE UNIQUE INDEX &&qdba..q$instat_log_PK
   ON &&qdba..q$instat_log (collect_seq)
TABLESPACE &&qtablespace
STORAGE (INITIAL     128K 
         NEXT        64K
         MINEXTENTS  1 
         PCTINCREASE 0);

ALTER TABLE &&qdba..q$instat_log
   ADD  (PRIMARY KEY (collect_seq));


CREATE UNIQUE INDEX &&qdba..q$instat_log_AK1
   ON &&qdba..q$instat_log (collect_sysdate,trend_hh24,trend_day)
TABLESPACE &&qtablespace
STORAGE (INITIAL  128K 
         NEXT     64K
         MINEXTENTS  1 
         PCTINCREASE 0);

CREATE SEQUENCE &&qdba..q$instat_seq
   START WITH 1
   INCREMENT BY 1
   NOMAXVALUE
   NOCACHE;


CREATE TABLE &&qdba..q$seg
   (schema    VARCHAR2(30) NOT NULL
   ,name      VARCHAR2(30) NOT NULL
   ,type      VARCHAR2(30) NOT NULL
/* may need file#,block#,dbaddr later for PL/SQL table index */
/* adding file# and block# to table   06/17/97   [JMB]       */
   ,file#     INTEGER   
   ,block#    INTEGER   
/* not using dbaddr yet       
   ,dbaddr   INTEGER   NOT NULL 
*/
   ,ts#        INTEGER   NOT NULL
   ,extents    INTEGER  NOT NULL
   ,nextext    INTEGER  NOT NULL
   ,used_blks     NUMBER   NULL
   ,free_blks     NUMBER   NULL
   ,blks_per_min  NUMBER   NULL
   ,add_date      DATE  NOT NULL
   ,drop_date     DATE  NULL
   ,calc_date     DATE  NOT NULL
   ,fail_date     DATE  NULL
   ,fail_reason    VARCHAR2(10)  NULL
   ,blks_per_min2  NUMBER        NULL
   ,watchcount     INTEGER
   ,last_watch_date  DATE
   ,obj#           NUMBER
/*   primary key   */
   ,CONSTRAINT q$seg_PK PRIMARY KEY 
         (type,name,schema) 
         USING INDEX
         TABLESPACE &&qtablespace
         STORAGE 
            (INITIAL     32K 
             NEXT        128K
             MINEXTENTS  1 
             PCTINCREASE 0)
   )
TABLESPACE &&qtablespace
STORAGE  
   (INITIAL     64K 
    NEXT        128K
    MINEXTENTS  1 
    PCTINCREASE 0);


CREATE TABLE &&qdba..q$segwatch
   (schema     VARCHAR2(30) NOT NULL
   ,name       VARCHAR2(30) NOT NULL
   ,type       VARCHAR2(30) NOT NULL
   ,add_date   DATE         NOT NULL
   ,keep_YN    VARCHAR2(10) NOT NULL      
/* added file# and block# to table   06/17/97   [JMB]       */
   ,file#     INTEGER   
   ,block#    INTEGER 
   )
TABLESPACE &&qtablespace
STORAGE  
   (INITIAL    32K 
    NEXT       32K
    MINEXTENTS 1 
    PCTINCREASE 0)
CACHE;

/* ----- config table for bgproc driver ------------*/
CREATE TABLE &&qdba..q$bgp_config
   (id               VARCHAR2(12)   NOT NULL PRIMARY KEY
   ,collect          VARCHAR2(12)   NOT NULL
            CONSTRAINT ck_collect 
            CHECK ( collect IN ('COLLECT','NO_COLLECT') )
   ,bench            VARCHAR2(12)   NOT NULL
            CONSTRAINT ck_bench
            CHECK ( bench IN ('BENCH','NO_BENCH') )
   ,alarm            VARCHAR2(12)   NOT NULL
            CONSTRAINT ck_alarm
            CHECK ( alarm IN ('ALARM','NO_ALARM') )
   ,segwatch         VARCHAR2(12)   NOT NULL
            CONSTRAINT ck_segwatch
            CHECK ( segwatch IN ('TEMP_SEGS','ALL_SEGS','NO_SEGWATCH') )
   ,keep_pkgs        VARCHAR2(12)   NOT NULL
            CONSTRAINT ck_keep_pkgs
            CHECK ( keep_pkgs IN ('KEEP','NO_KEEP') )
   ,collect_interval INTEGER        NOT NULL
            CONSTRAINT ck_collect_interval
            CHECK ( collect_interval > 0 )
   ,bench_interval   INTEGER        NOT NULL
            CONSTRAINT ck_bench_interval
            CHECK ( bench_interval > 0 )
   ,alarm_interval   INTEGER        NOT NULL
            CONSTRAINT ck_alarm_interval
            CHECK ( alarm_interval > 0 )
   ,detail_mode      VARCHAR2(12)   NOT NULL
            CONSTRAINT ck_detail_mode
            CHECK ( detail_mode IN ('DAILY','MANUAL','CONTINUOUS') )
   ,detail_purge     VARCHAR2(12)   NOT NULL
            CONSTRAINT ck_detail_purge
            CHECK ( detail_purge IN ('PURGE','NO_PURGE') )
   ,detail_start_date  DATE         NULL
   ,detail_end_date    DATE         NULL
   ,last_obj           INTEGER      NOT NULL
   ,last_objtype       VARCHAR2(20) NOT NULL
            CONSTRAINT ck_last_objtype
            CHECK ( last_objtype IN ('TABLE','INDEX','CLUSTER') )
   )
TABLESPACE &&qtablespace
PCTFREE	5
STORAGE (INITIAL 	1 
	      NEXT 		1
         MINEXTENTS  1
 	      PCTINCREASE 	0);


CREATE OR REPLACE TRIGGER &&qdba..q$bgp_config_UDbr 
BEFORE UPDATE OR DELETE
ON &&qdba..q$bgp_config
FOR EACH ROW
BEGIN
   IF UPDATING AND :NEW.id <> :OLD.id 
   THEN 
      raise_application_error(-20001, 'Cannot update ID');
   END IF;
   IF DELETING AND :OLD.id IN ('DEFAULT','CURRENT')
   THEN
      raise_application_error(-20001, 'Cannot DELETE id: '||:OLD.id);
   END IF;   
END;
/

ALTER TRIGGER &&qdba..q$bgp_config_UDbr DISABLE;

DELETE FROM &&qdba..q$bgp_config;

INSERT INTO &&qdba..q$bgp_config
   VALUES ('DEFAULT','COLLECT','NO_BENCH','NO_ALARM','TEMP_SEGS','KEEP'
                    ,600      ,600       ,300   
          ,'DAILY','PURGE',trunc(sysdate)+20/24,trunc(sysdate)+20/24
          ,-1,'TABLE');

INSERT INTO &&qdba..q$bgp_config
   VALUES ('CURRENT','COLLECT','NO_BENCH','NO_ALARM','TEMP_SEGS','KEEP'
                    ,600      ,600       ,300   
          ,'DAILY','PURGE',trunc(sysdate)+20/24,trunc(sysdate)+20/24
          ,-1,'TABLE');

COMMIT;

ALTER TRIGGER &&qdba..q$bgp_config_UDbr ENABLE;

