/* ==================================================== */
/* Copyright(c) 1997 by SAVANT Corp.                    */
/* All rights reserved.                                 */
/* ==================================================== */
set serveroutput on size 1000000

rem *****************************************************
rem * Tests the following calls:
rem * Q$INST2.GET_INSTANCE_DATA 
rem * Q$INST2.GET_INITPARMS 
rem *****************************************************
rem * Modification History:
rem *
rem * 6/22/97:  added TO_CHAR to dbms_output    [JMB]
rem *           calls because some ORACLEs barf
rem * 5/22/97:  added to QSQL project           [JMB]
rem *****************************************************

DECLARE
--
ip_db_block_size INTEGER;
ip_processes INTEGER;
ip_sessions  INTEGER;
ip_transactions INTEGER;
ip_enqueue_resources INTEGER;
ip_dml_locks INTEGER;
ip_temporary_table_locks INTEGER;
ip_db_files INTEGER;
ip_open_links INTEGER;
ip_open_cursors  INTEGER;
--
return_code    Q$INST2.return_code_var%TYPE;
return_key     Q$INST2.return_key_var%TYPE;
--
collect_sysdate  q$inst2.qDATE%TYPE;
collect_hsecs  INTEGER;
/*  ----------------------------- */ 
/*  InstID_rec_OUT expanded       */
/*  ----------------------------- */
db_name   q$inst2.db_name_var%TYPE;
db_domain q$inst2.db_domain_var%TYPE;
O7kernel_rel  VARCHAR2(20);
inst_start_date  q$inst2.qDATE%TYPE;
archivelog_mode  VARCHAR2(20);
log_sequence  INTEGER;
tot_size_KB  NUMBER;
tot_free_KB  NUMBER;
/* ------------------------------ */
/*     InstTF_rec_OUT expanded    */
/* ------------------------------ */
snapshots_exist  VARCHAR2(5);
dblinks_exist VARCHAR2(5);
open_dblinks_exist  VARCHAR2(5);
Xlock_waits_exist  VARCHAR2(5);
tempsegs_exist  VARCHAR2(5);
bgproc_exec_stat  VARCHAR2(10);
/* ------------------------------ */
/*    IOstats_rec_OUT  expanded   */
/* ------------------------------ */
dbfile_waits INTEGER;
dbfile_waittime INTEGER;
lgfile_waits INTEGER;
lgfile_waittime INTEGER;
dbf_physrds  INTEGER;
dbf_physwrts  INTEGER;
dbf_physblksrd INTEGER;
dbf_physblkswrt INTEGER;
IOskew      NUMBER;
IOstat_secs   INTEGER;
IOstat_date   q$inst2.qDATE%TYPE;
/* ------------------------------ */
/*   SGAactiv_rec_OUT expanded    */
/* ------------------------------ */
buffer_busy_waits INTEGER;
buffer_busy_waittime INTEGER;
latch_gets INTEGER;
latch_misses INTEGER;
latch_sleeps INTEGER;
latch_imm_gets INTEGER;
latch_imm_misses INTEGER;
dicache_gets INTEGER;
dicache_getmisses  INTEGER;
libcache_gets INTEGER;
libcache_gethits INTEGER;
libcache_pins INTEGER;
libcache_pinhits INTEGER;
libcache_reloads INTEGER;
rbs_gets INTEGER;
rbs_waits INTEGER;
rbs_xacts INTEGER;
crit_tempseg_extents INTEGER;
crit_tempseg_maxexts INTEGER;
crit_rbseg_extents INTEGER;
crit_rbseg_maxexts INTEGER;
active_tempsegs   INTEGER;
/* ------------------------------ */
/*  SGAdata_rec_OUT expanded      */
/* ------------------------------ */
SGA_size_KB NUMBER;
fixed_area_KB NUMBER;
db_buffer_KB NUMBER;
db_buffer_free_KB NUMBER;
redo_buffer_KB NUMBER;
shpool_KB NUMBER;
shpool_free_KB NUMBER;
shpool_maxfree_KB NUMBER;
shpool_free_exts INTEGER;
dictionary_cache_KB NUMBER;
library_cache_KB NUMBER;
SQLarea_KB  NUMBER;
sess_MTS_KB  NUMBER;
/* ------------------------------ */
/*    sysstat_rec_OUT expanded    */
/* ------------------------------ */
logons  q$inst2.statval_var%TYPE;
logons_cum q$inst2.statval_var%TYPE;
open_cursors q$inst2.statval_var%TYPE;
open_cursors_cum  q$inst2.statval_var%TYPE;
commits  q$inst2.statval_var%TYPE;
db_block_gets  q$inst2.statval_var%TYPE;
consistent_gets  q$inst2.statval_var%TYPE;
logical_reads  q$inst2.statval_var%TYPE;
physical_reads  q$inst2.statval_var%TYPE;
enqueue_requests  q$inst2.statval_var%TYPE;
enqueue_timeouts  q$inst2.statval_var%TYPE;
user_calls  q$inst2.statval_var%TYPE;
parse_count  q$inst2.statval_var%TYPE;
execute_count  q$inst2.statval_var%TYPE;
recursive_calls  q$inst2.statval_var%TYPE;
sorts_disk  q$inst2.statval_var%TYPE;
sorts_memory   q$inst2.statval_var%TYPE;
table_scan_rows_gotten   q$inst2.statval_var%TYPE;
table_fetch_rowid  q$inst2.statval_var%TYPE;
table_scans_short  q$inst2.statval_var%TYPE;
table_scans_long   q$inst2.statval_var%TYPE;
table_fetch_cont_row  q$inst2.statval_var%TYPE;
redo_size  q$inst2.statval_var%TYPE;
redo_log_space_req  q$inst2.statval_var%TYPE;
redo_buf_alloc_retries   q$inst2.statval_var%TYPE;
redo_writes  q$inst2.statval_var%TYPE;
redo_log_space_wait_time  q$inst2.statval_var%TYPE;
redo_entries  q$inst2.statval_var%TYPE;
redo_blocks_written  q$inst2.statval_var%TYPE;
summed_dirty_queue_len   q$inst2.statval_var%TYPE;
write_requests  q$inst2.statval_var%TYPE;
dirty_buf_inspected  q$inst2.statval_var%TYPE;
DBWR_make_free_req   q$inst2.statval_var%TYPE;
DBWR_free_buf_found  q$inst2.statval_var%TYPE;
sess_uga_memory  q$inst2.statval_var%TYPE;
sess_pga_memory  q$inst2.statval_var%TYPE;
--
/* added SQL*Net related data as/per Instance Overview design mod */
SQLnet_rndtrips         q$inst2.statval_var%TYPE;
SQLnetKB_to_client      NUMBER;
SQLnetKB_from_client    NUMBER;
dblink_rndtrips         q$inst2.statval_var%TYPE;
dblinkKB_to_client      NUMBER;
dblinkKB_from_client    NUMBER;
--
sysstat_secs   INTEGER;
sysstat_date   q$inst2.qDATE%TYPE;
--
/* added MTS data as/per design mods    */
conn_dedicated      INTEGER;
conn_shared         INTEGER;
MTS_dispatchers     INTEGER;
MTS_servers         INTEGER;
disp_busy_hsec      INTEGER;
disp_idle_hsec      INTEGER;
disp_waittime_hsec  INTEGER;
disp_totalqueue     INTEGER;
serv_busy_hsec      INTEGER;
serv_idle_hsec      INTEGER;
serv_waittime_hsec  INTEGER;
serv_totalqueue     INTEGER;
--
temp_stat      NUMBER:=0;
BEGIN
   Q$INST2.get_Instance
   (return_code
   ,return_key
,collect_sysdate
,collect_hsecs
/*  ----------------------------- */ 
/*  InstID_rec_OUT expanded       */
/*  ----------------------------- */
,db_name 
,db_domain
,O7kernel_rel
,inst_start_date
,archivelog_mode
,log_sequence
,tot_size_KB
,tot_free_KB
/* ------------------------------ */
/*     InstTF_rec_OUT expanded    */
/* ------------------------------ */
,snapshots_exist
,dblinks_exist
,open_dblinks_exist
,Xlock_waits_exist
,tempsegs_exist
,bgproc_exec_stat
/* ------------------------------ */
/*    IOstats_rec_OUT  expanded   */
/* ------------------------------ */
,dbfile_waits
,dbfile_waittime
,lgfile_waits
,lgfile_waittime
,dbf_physrds
,dbf_physwrts
,dbf_physblksrd
,dbf_physblkswrt
,IOskew
,IOstat_secs
,IOstat_date
/* ------------------------------ */
/*   SGAactiv_rec_OUT expanded    */
/* ------------------------------ */
,buffer_busy_waits
,buffer_busy_waittime
,latch_gets
,latch_misses
,latch_sleeps
,latch_imm_gets
,latch_imm_misses
,dicache_gets
,dicache_getmisses
,libcache_gets
,libcache_gethits
,libcache_pins
,libcache_pinhits
,libcache_reloads
,rbs_gets
,rbs_waits
,rbs_xacts
,crit_tempseg_extents
,crit_tempseg_maxexts
,crit_rbseg_extents
,crit_rbseg_maxexts
,active_tempsegs
/* ------------------------------ */
/*  SGAdata_rec_OUT expanded      */
/* ------------------------------ */
,SGA_size_KB
,fixed_area_KB
,db_buffer_KB
,db_buffer_free_KB
,redo_buffer_KB
,shpool_KB
,shpool_free_KB
,shpool_maxfree_KB
,shpool_free_exts
,dictionary_cache_KB
,library_cache_KB
,SQLarea_KB
,sess_MTS_KB
/* ------------------------------ */
/*    sysstat_rec_OUT expanded    */
/* ------------------------------ */
,logons
,logons_cum
,open_cursors
,open_cursors_cum
,commits
,db_block_gets
,consistent_gets
,logical_reads
,physical_reads
,enqueue_requests
,enqueue_timeouts
,user_calls
,parse_count
,execute_count
,recursive_calls
,sorts_disk
,sorts_memory
,table_scan_rows_gotten
,table_fetch_rowid
,table_scans_short
,table_scans_long
,table_fetch_cont_row
,redo_size
,redo_log_space_req
,redo_buf_alloc_retries
,redo_writes
,redo_log_space_wait_time
,redo_entries
,redo_blocks_written
,summed_dirty_queue_len
,write_requests
,dirty_buf_inspected
,DBWR_make_free_req
,DBWR_free_buf_found
,sess_uga_memory
,sess_pga_memory
,SQLnet_rndtrips
,SQLnetKB_to_client
,SQLnetKB_from_client
,dblink_rndtrips
,dblinkKB_to_client
,dblinkKB_from_client
,sysstat_secs
,sysstat_date
/* ------------------------------ */
/*    MTSdata_rec_OUT expanded    */
/* ------------------------------ */
,conn_dedicated
,conn_shared
,MTS_dispatchers
,MTS_servers
,disp_busy_hsec
,disp_idle_hsec
,disp_waittime_hsec
,disp_totalqueue
,serv_busy_hsec
,serv_idle_hsec
,serv_waittime_hsec
,serv_totalqueue);
--
--
   dbms_output.put_line('Instance load return code: '||TO_CHAR(return_code) );
   dbms_output.put_line('Instance load return key: '||return_key );
--
   dbms_output.put_line('*********************************************');
   dbms_output.put_line('*****  Instance Identification data *********');
   dbms_output.put_line('*********************************************');
   dbms_output.put_line('db_name: '||db_name );        
   dbms_output.put_line('db_domain: '||db_domain );      
   dbms_output.put_line('O7kernel_rel: '||O7kernel_rel );   
   dbms_output.put_line('inst_start_date: '||inst_start_date );
   dbms_output.put_line('archivelog_mode: '||archivelog_mode );
   dbms_output.put_line('log_sequence: '||TO_CHAR(log_sequence) );
   dbms_output.put_line('tot_size_KB: '||TO_CHAR(tot_size_KB) );
   dbms_output.put_line('tot_free_KB: '||TO_CHAR(tot_free_KB) );
   --
   dbms_output.put_line('*********************************************');
   dbms_output.put_line('*****   Instance Booleans (T/F)   ***********');
   dbms_output.put_line('*********************************************');
   dbms_output.put_line('snapshots_exist: '||snapshots_exist );
   dbms_output.put_line('dblinks_exist: '||dblinks_exist );
   dbms_output.put_line('open_dblinks_exist: '||open_dblinks_exist );
   dbms_output.put_line('Xlock_waits_exist: '||Xlock_waits_exist );
   dbms_output.put_line('tempsegs_exist: '||tempsegs_exist );
   dbms_output.put_line('bgproc_exec_stat: '||bgproc_exec_stat );
   --
   dbms_output.put_line('*********************************************');
   dbms_output.put_line('*****     Instance I/O data      ************');
   dbms_output.put_line('*********************************************');
   dbms_output.put_line('dbfile_waits: '||TO_CHAR(dbfile_waits) );
   dbms_output.put_line('dbfile_waittime: '||TO_CHAR(dbfile_waittime) );
   dbms_output.put_line('lgfile_waits: '||TO_CHAR(lgfile_waits) );
   dbms_output.put_line('lgfile_waittime: '||TO_CHAR(lgfile_waittime) );
   dbms_output.put_line('dbf_physrds: '||TO_CHAR(dbf_physrds) );
   dbms_output.put_line('dbf_physwrts: '||TO_CHAR(dbf_physwrts) );
   dbms_output.put_line('dbf_physblksrd: '||TO_CHAR(dbf_physblksrd) );
   dbms_output.put_line('dbf_physblkswrt: '||TO_CHAR(dbf_physblkswrt) );
   dbms_output.put_line('IOskew: '||TO_CHAR(IOskew) );
   dbms_output.put_line('IOstat_secs: '||TO_CHAR(IOstat_secs) );
   dbms_output.put_line('IOstat_date: '||IOstat_date );
   --
   temp_stat:=dbfile_waittime/dbfile_waits;
   dbms_output.put_line('Dbfile I/O avg wait: '||TO_CHAR(temp_stat) );
   --
   temp_stat:=lgfile_waittime/lgfile_waits;
   dbms_output.put_line('Logfile I/O avg wait: '||TO_CHAR(temp_stat) );
   --
   temp_stat:=(dbf_physrds*60)/IOstat_secs;
   dbms_output.put_line('Phys Rds per min: '||TO_CHAR(temp_stat) );
   --
   temp_stat:=(dbf_physwrts*60)/IOstat_secs;
   dbms_output.put_line('Phys Wrts per min: '||TO_CHAR(temp_stat) );
   --
   temp_stat:=(redo_size*60)/sysstat_secs;
   dbms_output.put_line('Redo gen per min: '||TO_CHAR(temp_stat) );
   --
   dbms_output.put_line('*********************************************');
   dbms_output.put_line('*****  Instance SGA activity data   *********');
   dbms_output.put_line('*********************************************');
   dbms_output.put_line('buffer_busy_waits: '||TO_CHAR(buffer_busy_waits) );
   dbms_output.put_line('buffer_busy_waittime: '||TO_CHAR(buffer_busy_waittime) );
   dbms_output.put_line('latch_gets: '||TO_CHAR(latch_gets) );
   dbms_output.put_line('latch_misses: '||TO_CHAR(latch_misses) );
   dbms_output.put_line('latch_sleeps: '||TO_CHAR(latch_sleeps) );
   dbms_output.put_line('latch_imm_gets: '||TO_CHAR(latch_imm_gets) );
   dbms_output.put_line('latch_imm_misses: '||TO_CHAR(latch_imm_misses) );
   dbms_output.put_line('dicache_gets: '||TO_CHAR(dicache_gets) );
   dbms_output.put_line('dicache_getmisses: '||TO_CHAR(dicache_getmisses) );
   dbms_output.put_line('libcache_gets: '||TO_CHAR(libcache_gets) );
   dbms_output.put_line('libcache_gethits: '||TO_CHAR(libcache_gethits) ); 
   dbms_output.put_line('libcache_pins: '||TO_CHAR(libcache_pins) );
   dbms_output.put_line('libcache_pinhits: '||TO_CHAR(libcache_pinhits) );
   dbms_output.put_line('libcache_reloads: '||TO_CHAR(libcache_reloads) );
   dbms_output.put_line('rbs_gets: '||TO_CHAR(rbs_gets) );
   dbms_output.put_line('rbs_waits: '||TO_CHAR(rbs_waits) );
   dbms_output.put_line('rbs_xacts: '||TO_CHAR(rbs_xacts) );
   dbms_output.put_line('crit_tempseg_extents: '||TO_CHAR(crit_tempseg_extents) );
   dbms_output.put_line('crit_tempseg_maxexts: '||TO_CHAR(crit_tempseg_maxexts) );
   dbms_output.put_line('active_tempsegs: '||TO_CHAR(active_tempsegs) );
   dbms_output.put_line('crit_rbseg_extents: '||TO_CHAR(crit_rbseg_extents) );
   dbms_output.put_line('crit_rbseg_maxexts: '||TO_CHAR(crit_rbseg_maxexts) );
   --
   temp_stat:=latch_misses/latch_gets;
   dbms_output.put_line('Latch getmiss ratio: '||TO_CHAR(temp_stat) );
   --
   temp_stat:=rbs_waits/rbs_gets;
   dbms_output.put_line('Undo header getmiss ratio: '||TO_CHAR(temp_stat) );
   --
   temp_stat:=libcache_gethits/libcache_gets;
   dbms_output.put_line('Lib cache gethitratio: '||TO_CHAR(temp_stat) );
   --
   temp_stat:=libcache_pinhits/libcache_pins;
   dbms_output.put_line('Lib cache pinhitratio: '||TO_CHAR(temp_stat) );
   --
   temp_stat:=(dicache_gets-dicache_getmisses)/
               dicache_gets;
   dbms_output.put_line('Dictionary cache gethitratio: '||TO_CHAR(temp_stat) );
   --
   temp_stat:=1-(physical_reads/
                  (consistent_gets
                  +db_block_gets));
   dbms_output.put_line('Buffer Hit Ratio: '||TO_CHAR(temp_stat) );
   --
   dbms_output.put_line('*********************************************');
   dbms_output.put_line('*****  Instance SGA component sizes *********');
   dbms_output.put_line('*********************************************');
   dbms_output.put_line('SGA_size_KB: '||TO_CHAR(SGA_size_KB) );
   dbms_output.put_line('fixed_area_KB: '||TO_CHAR(fixed_area_KB) );
   dbms_output.put_line('db_buffer_KB: '||TO_CHAR(db_buffer_KB) );
   dbms_output.put_line('db_buffer_free_KB: '||TO_CHAR(db_buffer_free_KB) );
   dbms_output.put_line('redo_buffer_KB: '||TO_CHAR(redo_buffer_KB) );
   dbms_output.put_line('shpool_KB: '||TO_CHAR(shpool_KB) );
   dbms_output.put_line('shpool_free_KB: '||TO_CHAR(shpool_free_KB) );
   dbms_output.put_line('shpool_maxfree_KB: '||TO_CHAR(shpool_maxfree_KB) );
   dbms_output.put_line('shpool_free_exts: '||TO_CHAR(shpool_free_exts) );
   dbms_output.put_line('dictionary_cache_KB: '||TO_CHAR(dictionary_cache_KB) );
   dbms_output.put_line('library_cache_KB: '||TO_CHAR(library_cache_KB) );
   dbms_output.put_line('SQLarea_KB: '||TO_CHAR(SQLarea_KB) );
   dbms_output.put_line('sess_MTS_KB: '||TO_CHAR(sess_MTS_KB) );
   --
   dbms_output.put_line('*********************************************');
   dbms_output.put_line('*****  Instance System statistics   *********');
   dbms_output.put_line('*********************************************');
   dbms_output.put_line('logons: '||TO_CHAR(logons) );
   dbms_output.put_line('logons_cum: '||TO_CHAR(logons_cum) );
   dbms_output.put_line('open_cursors: '||TO_CHAR(open_cursors) ); 
   dbms_output.put_line('open_cursors_cum: '||TO_CHAR(open_cursors_cum) );
   dbms_output.put_line('commits: '||TO_CHAR(commits) );
   dbms_output.put_line('db_block_gets: '||TO_CHAR(db_block_gets) );
   dbms_output.put_line('consistent_gets: '||TO_CHAR(consistent_gets) );
   dbms_output.put_line('logical_reads: '||TO_CHAR(logical_reads) );
   dbms_output.put_line('physical_reads: '||TO_CHAR(physical_reads) );
   dbms_output.put_line('enqueue_requests: '||TO_CHAR(enqueue_requests) );
   dbms_output.put_line('enqueue_timeouts: '||TO_CHAR(enqueue_timeouts) );
   dbms_output.put_line('user_calls: '||TO_CHAR(user_calls) );
   dbms_output.put_line('parse_count: '||TO_CHAR(parse_count) );
   dbms_output.put_line('execute_count: '||TO_CHAR(execute_count) );
   dbms_output.put_line('recursive_calls: '||TO_CHAR(recursive_calls) );
   dbms_output.put_line('sorts_disk: '||TO_CHAR(sorts_disk) );
   dbms_output.put_line('sorts_memory: '||TO_CHAR(sorts_memory) );
   dbms_output.put_line('table_scan_rows_gotten: '||TO_CHAR(table_scan_rows_gotten) );
   dbms_output.put_line('table_fetch_rowid: '||TO_CHAR(table_fetch_rowid) );
   dbms_output.put_line('table_scans_short: '||TO_CHAR(table_scans_short) );
   dbms_output.put_line('table_scans_long: '||TO_CHAR(table_scans_long) );
   dbms_output.put_line('table_fetch_continued_row: '||TO_CHAR(table_fetch_cont_row) );
   dbms_output.put_line('redo_size: '||TO_CHAR(redo_size) );
   dbms_output.put_line('redo_log_space_req: '||TO_CHAR(redo_log_space_req) );
   dbms_output.put_line('redo_buf_alloc_retries: '||TO_CHAR(redo_buf_alloc_retries) );
   dbms_output.put_line('redo_writes: '||TO_CHAR(redo_writes) );
   dbms_output.put_line('redo_log_space_wait_time: '||TO_CHAR(redo_log_space_wait_time) );
   dbms_output.put_line('redo_entries: '||TO_CHAR(redo_entries) );
   dbms_output.put_line('redo_blocks_written: '||TO_CHAR(redo_blocks_written) );
   dbms_output.put_line('summed_dirty_queue_len: '||TO_CHAR(summed_dirty_queue_len) );
   dbms_output.put_line('write_requests: '||TO_CHAR(write_requests) );
   dbms_output.put_line('dirty_buf_inspected: '||TO_CHAR(dirty_buf_inspected) );
   dbms_output.put_line('DBWR_make_free_req: '||TO_CHAR(DBWR_make_free_req) );
   dbms_output.put_line('DBWR_free_buf_found: '||TO_CHAR(DBWR_free_buf_found) );
   dbms_output.put_line('sysstat_secs: '||TO_CHAR(sysstat_secs) );
   dbms_output.put_line('sysstat_date: '||sysstat_date );
   --
   temp_stat:=sorts_disk+sorts_memory;
   dbms_output.put_line('Total Sorts: '||TO_CHAR(temp_stat) );
   temp_stat:=(temp_stat*60)/sysstat_secs;
   dbms_output.put_line('Total Sorts per min: '||TO_CHAR(temp_stat) );
   --
   temp_stat:=table_scans_short+table_scans_long;
   dbms_output.put_line('Total Scans: '||TO_CHAR(temp_stat) );
   temp_stat:=(temp_stat*60)/sysstat_secs;
   dbms_output.put_line('Total Scans per min: '||TO_CHAR(temp_stat) );
   --
   dbms_output.put_line('*********************************************');
   dbms_output.put_line('*****  NEW:  SQL*Net info           *********');
   dbms_output.put_line('*********************************************');
   dbms_output.put_line('SQLnet_rndtrips: '||TO_CHAR(SQLnet_rndtrips) );
   dbms_output.put_line('SQLnetKB_to_client: '||TO_CHAR(SQLnetKB_to_client) );
   dbms_output.put_line('SQLnetKB_from_client: '||TO_CHAR(SQLnetKB_from_client) );
   dbms_output.put_line('dblink_rndtrips: '||TO_CHAR(dblink_rndtrips) );
   dbms_output.put_line('dblinkKB_to_client: '||TO_CHAR(dblinkKB_to_client) );
   dbms_output.put_line('dblinkKB_from_client: '||TO_CHAR(dblinkKB_from_client) );
   --
   dbms_output.put_line('*********************************************');
   dbms_output.put_line('*****  NEW:  MTS data               *********');
   dbms_output.put_line('*********************************************');
   dbms_output.put_line('conn_dedicated: '||TO_CHAR(conn_dedicated) );
   dbms_output.put_line('conn_shared: '||TO_CHAR(conn_shared) );
   dbms_output.put_line('MTS_dispatchers: '||TO_CHAR(MTS_dispatchers) );
   dbms_output.put_line('MTS_servers: '||TO_CHAR(MTS_servers) );
   dbms_output.put_line('disp_busy_hsec: '||TO_CHAR(disp_busy_hsec) );
   dbms_output.put_line('disp_idle_hsec: '||TO_CHAR(disp_idle_hsec) );
   dbms_output.put_line('disp_waittime_hsec: '||TO_CHAR(disp_waittime_hsec) );
   dbms_output.put_line('disp_totalqueue: '||TO_CHAR(disp_totalqueue) );
   dbms_output.put_line('serv_busy_hsec: '||TO_CHAR(serv_busy_hsec) );
   dbms_output.put_line('serv_idle_hsec: '||TO_CHAR(serv_idle_hsec) );
   dbms_output.put_line('serv_waittime_hsec: '||TO_CHAR(serv_waittime_hsec) );
   dbms_output.put_line('serv_totalqueue: '||TO_CHAR(serv_totalqueue) );
   --
   /* -------------- derived data ------------------*/
   temp_stat :=0;
   IF (serv_busy_hsec+serv_idle_hsec) >0
   THEN
   temp_stat:=serv_busy_hsec/(serv_busy_hsec+serv_idle_hsec);
   END IF;
   dbms_output.put_line('serv_busyrate: '||TO_CHAR(temp_stat) );
   --
   temp_stat :=0;
   IF (disp_busy_hsec+disp_idle_hsec) >0
   THEN
   temp_stat:=disp_busy_hsec/(disp_busy_hsec+disp_idle_hsec);
   END IF;
   dbms_output.put_line('disp_busyrate: '||TO_CHAR(temp_stat) );
   --
   temp_stat :=0;
   IF (serv_totalqueue) >0
   THEN
   temp_stat:=serv_waittime_hsec/(serv_totalqueue);
   END IF;
   dbms_output.put_line('Request (server) Queue Avg Wait: '||
            TO_CHAR(temp_stat) );
   --
   temp_stat :=0;
   IF (disp_totalqueue) >0
   THEN
   temp_stat:=disp_waittime_hsec/(disp_totalqueue);
   END IF;
   dbms_output.put_line('Response (dispatcher) Queue Avg Wait: '||
         TO_CHAR(temp_stat) );
   --
   /* ------------------------------------------------------- */
   --
   -- execute get_initparms
   q$inst2.get_initparms 
      (db_name
      ,db_domain
      ,ip_db_block_size
      ,ip_processes
      ,ip_sessions
      ,ip_transactions
      ,ip_enqueue_resources
      ,ip_dml_locks
      ,ip_temporary_table_locks
      ,ip_db_files
      ,ip_open_links
      ,ip_open_cursors);
   --
   --
   dbms_output.put_line('*********************************************');
   dbms_output.put_line('*****  Instance Init.ora parms      *********');
   dbms_output.put_line('*********************************************');
   dbms_output.put_line('db_name: '||db_name );
   dbms_output.put_line('db_domain: '||db_domain );
   dbms_output.put_line('db_block_size: '||TO_CHAR(ip_db_block_size) );
   dbms_output.put_line('processes: '||TO_CHAR(ip_processes) );
   dbms_output.put_line('sessions: '||TO_CHAR(ip_sessions) );
   dbms_output.put_line('transactions: '||TO_CHAR(ip_transactions) );
   dbms_output.put_line('enqueue_resources: '||TO_CHAR(ip_enqueue_resources) );
   dbms_output.put_line('dml_locks: '||TO_CHAR(ip_dml_locks) );
   dbms_output.put_line('temporary_table_locks: '||
            TO_CHAR(ip_temporary_table_locks) );
   dbms_output.put_line('db_files: '||TO_CHAR(ip_db_files) );
   dbms_output.put_line('open_links: '||TO_CHAR(ip_open_links) );
   dbms_output.put_line('open_cursors: '||TO_CHAR(ip_open_cursors) );
   --
END;
/


