REM   --------------------------------------------------------------------------
REM   TECHSUP.SQL   
REM
REM   Copyright(c) 1997,1998 by Savant Corporation
REM   All rights reserved.             
REM   ---------------------------------------------------------------------------
REM ==============================================================
REM Revision History:
REM
REM 12/29/97: numerous fixes to bugs in script          [JMB]
REM 12/23/97: updates to script                         [JAL]
REM 12/01/97: original creation                         [JAL]
REM ==============================================================

rem ==================================================================
rem ================Checking Oracle Version===========================
rem ==================================================================
prompt **** Checking Oracle Versions ****
col product format a30
col version format a10
col status format a19

SELECT * 
  FROM product_component_version;

rem ==================================================================
rem ================Shared Pool Test==================================
rem ==================================================================
prompt **** DBMS_SHARED_POOL test ****
col msg head "MESSAGE" format a60

SELECT 'SYS.DBMS_SHARED_POOL Package status: '||status    msg 
  FROM sys.dba_objects
 WHERE object_name='DBMS_SHARED_POOL' 
   AND owner = 'SYS'
UNION
SELECT 'SYS.DBMS_SHARED_POOL Package status: DOES NOT EXIST'   msg
  FROM dual
 WHERE NOT EXISTS 
      (SELECT 'X' 
         FROM  sys.dba_objects 
        WHERE object_name = 'DBMS_SHARED_POOL' 
          AND  owner = 'SYS');
rem ==================================================================
rem =================Invalid Q Objects================================
rem ==================================================================
prompt **** Searching for invalid Q objects ****

SELECT * 
  FROM dba_objects 
 WHERE status = 'INVALID'
   AND owner = 'QDBA';

rem ==================================================================
rem =================Invalid SYS Objects==============================
rem ==================================================================
prompt **** Searching for invalid 'SYS' objects ****

col object_name format a30
col owner format a20
col object_type format a15

SELECT owner, object_type, object_name 
  FROM dba_objects 
 WHERE (status = 'INVALID' AND owner = 'SYS') 
    OR (object_name like 'DBMS%' AND owner != 'SYS' AND object_type != 'SYNONYM');

rem ==================================================================
rem =================Old Q Processes==================================
rem ==================================================================
prompt **** Searching for old Q Diagnostic Engine jobs ****
col what format a40 word_wrap
col log_user format a20

SELECT job, log_user, failures,broken, what 
  FROM dba_jobs 
 WHERE UPPER(what) LIKE '%Q$BGPROC%';

rem ==================================================================
rem =================Next Extent Test=================================
rem ==================================================================
prompt **** Searching for next extent too large for SYSTEM tablespace ****
col owner format a15;
col segment_name format a20;
col next_extent_kb format 99999990;
col tbs_maxfree_kb format 99999990;

SELECT  owner,segment_name,next_extent/1024 next_extent_KB
       ,MAX(fs.bytes)/1024 tbs_maxfree_KB 
  FROM  dba_segments    s
       ,dba_free_space fs 
 WHERE s.tablespace_name = fs.tablespace_name 
   AND s.tablespace_name = 'SYSTEM' 
 GROUP BY owner,segment_name,next_extent 
HAVING next_extent > MAX(fs.bytes);

rem ==================================================================
rem =================Jobs Running=====================================
rem ==================================================================
prompt **** Jobs Currently Running in the Queue ****
col username format a20
col what format a40 word_wrap

SELECT JR.sid, S.username, JR.job, JR.failures, J.what 
  FROM dba_jobs_running      JR
       ,dba_jobs             J
       ,v$session            S
 WHERE J.job = JR.job
   AND S.sid = JR.sid;

rem ==================================================================
rem =================DB Parameters====================================
rem ==================================================================
prompt **** Listing Oracle INIT.ORA parameters ****
col name format a45;
col value format a37;

SELECT name, value 
  FROM v$parameter 
 ORDER BY 1;

rem ==================================================================
rem =================Checking for pl\sql errors=======================
rem ==================================================================
rem This section may needing edting to point at non-default install directory
rem The three scripts are currently found in the %\savant\qsql\ directory
rem The default location is referenced below

rem prompt  checking for PL\SQL runtime errors
rem @ c:\savant\qsql\q_t1.sql;
rem @ c:\savant\qsql\q_t2.sql;
rem @ c:\savant\qsql\q_t3.sql;

