rem $DBA/tabanal.sql
rem
rem Displays an analysis of a specific tablespace for a given database.
rem Used when a tablespace's free space is getting too low and you want to see
rem what types of records are filling up the tablespace.
rem
rem Parameters:
rem    &1 = Oracle SID
rem    &2 = Tablespace name to be analyzed
rem
rem Also requires that tabanaltmp.sql is present, so it can be executed
rem
rem Created by	Brian Lomasky,
rem
rem <<<<<<<<<<< Modification History >>>>>>>>>>>>
rem   Date	Programmer	Description
rem 11/14/95	Brian Lomasky	Original release
rem
set feedback off
set termout off
set verify off
set pagesize 9999
column sumbytes noprint new_value xbytes
select sum(bytes) sumbytes
from dba_segments where tablespace_name = '&&2';
rem
spool tabanal.lis
rem
ttitle center 'Analysis of ' &&2 ' tablespace for ' &&1 ' database' skip 2
column owner format a10 heading "Owner"
column segment_name format a30 heading "Name"
column segment_type format a8 heading "Type"
column bytes format 999,999,999 heading "Bytes"
column extents format 99 heading "Extents"
compute sum of bytes on report
break on report
select owner, segment_name, segment_type, bytes, extents
from dba_segments
where tablespace_name = '&&2' and bytes > to_number(nvl('&xbytes','0')) / 300
order by bytes desc;
rem
@tabanaltmp
@tabanalitmp
rem
set termout on
spool off
exit
